[![Build Status](https://github.com/JuliaGraphics/Cairo.jl/workflows/CI/badge.svg)](https://github.com/JuliaGraphics/Cairo.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/JuliaGraphics/Cairo.jl/branch/master/graph/badge.svg?token=3StavIHX8q)](https://codecov.io/gh/JuliaGraphics/Cairo.jl)

## Bindings to the Cairo graphics library ##

Adaptation to [Cairo](https://www.cairographics.org/), a 2D graphics library with support for multiple output devices. 

Some of the functions implemented by this wrapper may be documented in [Graphics.jl](https://juliagraphics.github.io/Graphics.jl/stable/).

There is an extensive set of [examples](samples/Samples.md).

## header to provide surface and context
using Cairo
c = CairoARGBSurface(512,512);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,512.0,512.0); # background
fill(cr);
restore(cr);

save(cr);

function operator_demo(operator_index)
    c = CairoARGBSurface(126,98);
    cr = CairoContext(c);
    operators = [
        (Cairo.OPERATOR_CLEAR,"OPERATOR_CLEAR"),
        (Cairo.OPERATOR_SOURCE,"OPERATOR_SOURCE"),
        (Cairo.OPERATOR_OVER,"OPERATOR_OVER"),
        (Cairo.OPERATOR_IN,"OPERATOR_IN"),
        (Cairo.OPERATOR_OUT,"OPERATOR_OUT"),
        (Cairo.OPERATOR_ATOP,"OPERATOR_ATOP"),
        (Cairo.OPERATOR_DEST,"OPERATOR_DEST"),
        (Cairo.OPERATOR_DEST_OVER,"OPERATOR_DEST_OVER"),
        (Cairo.OPERATOR_DEST_IN,"OPERATOR_DEST_IN"),
        (Cairo.OPERATOR_DEST_OUT,"OPERATOR_DEST_OUT"),
        (Cairo.OPERATOR_DEST_ATOP,"OPERATOR_DEST_ATOP"),
        (Cairo.OPERATOR_XOR,"OPERATOR_XOR"),
        (Cairo.OPERATOR_ADD,"OPERATOR_ADD"),
        (Cairo.OPERATOR_SATURATE,"OPERATOR_SATURATE"),
        (Cairo.OPERATOR_MULTIPLY,"OPERATOR_MULTIPLY"),
        (Cairo.OPERATOR_SCREEN,"OPERATOR_SCREEN"),
        (Cairo.OPERATOR_OVERLAY,"OPERATOR_OVERLAY"),
        (Cairo.OPERATOR_DARKEN,"OPERATOR_DARKEN"),
        (Cairo.OPERATOR_LIGHTEN,"OPERATOR_LIGHTEN")]

    save(cr)
    set_source_rgb(cr, 0.9, 0.9, 0.9)
    paint(cr);

    save(cr)
    scale(cr,6,6)
    rectangle(cr, 0, 5, 12, 9)
    set_source_rgba(cr, 0.7, 0, 0, 0.8)
    fill(cr)

    set_operator(cr, operators[operator_index][1])

    rectangle(cr, 4, 2, 12, 9)
    set_source_rgba(cr, 0, 0, 0.9, 0.4)
    fill(cr)

    local_operator = get_operator(cr)
    restore(cr)

    move_to(cr,0,10)
    set_source_rgb(cr, 0,0,0)
    show_text(cr,operators[local_operator+1][2])

    restore(cr)
    c
end

for k=1:19
    save(cr)
    translate(cr,6+(128*mod(k-1,4)),24+(100*div(k-1,4)))
    set_source(cr,operator_demo(k))
    paint(cr)
    restore(cr)
end

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_operators.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, following here

move_to(cr, 50.0, 75.0);
line_to(cr, 200.0, 75.0);

move_to(cr, 50.0, 125.0);
line_to(cr, 200.0, 125.0);

move_to(cr, 50.0, 175.0);
line_to(cr, 200.0, 175.0);

set_line_width(cr, 30.0);
set_line_cap(cr, Cairo.CAIRO_LINE_CAP_ROUND);
stroke(cr);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_multi_segment_caps.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, following here
image = read_from_png("data/mulberry.png");
w = image.width; 
h = image.height;

pattern = CairoPattern(image);
pattern_set_extend(pattern, Cairo.EXTEND_REPEAT);

translate(cr, 128.0, 128.0);
rotate(cr, pi / 4);
scale(cr, 1 / sqrt(2), 1 / sqrt(2));
translate(cr, -128.0, -128.0);

m = CairoMatrix(w/256.0 * 5.0,0,0,h/256.0 * 5.0,0,0);
#matrix_init_scale (&matrix, w/256.0 * 5.0, h/256.0 * 5.0);

set_matrix(pattern, m);
set_source(cr, pattern);

rectangle(cr, 0, 0, 256.0, 256.0);
fill(cr);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_imagepattern.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, following here

dashes = [50.0,  # ink 
          10.0,  # skip
          10.0,  # ink 
          10.0   # skip
          ];
#ndash = length(dashes); not implemented as ndash on set_dash
offset = -50.0;

set_dash(cr, dashes, offset); 
set_line_width(cr, 10.0);

move_to(cr, 128.0, 25.6);
line_to(cr, 230.4, 230.4);
rel_line_to(cr, -102.4, 0.0);
curve_to(cr, 51.2, 230.4, 51.2, 128.0, 128.0, 128.0);

stroke(cr);


## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_dash.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, following here

# a custom shape that could be wrapped in a function */
x         = 25.6;        # parameters like cairo_rectangle */
y         = 25.6;
xw         = 204.8;
yw        = 204.8;
aspect        = 1.0;     # aspect ratio */
corner_radius = yw / 10.0;   #* and corner curvature radius */

radius = corner_radius / aspect;
degrees = pi / 180.0;

new_sub_path(cr);
arc(cr, x + xw - radius, y + radius, radius, -90 * degrees, 0 * degrees);
arc(cr, x + xw - radius, y + yw - radius, radius, 0 * degrees, 90 * degrees);
arc(cr, x + radius, y + yw - radius, radius, 90 * degrees, 180 * degrees);
arc(cr, x + radius, y + radius, radius, 180 * degrees, 270 * degrees);
close_path(cr);

set_source_rgb(cr, 0.5, 0.5, 1);
fill_preserve(cr);
set_source_rgba(cr, 0.5, 0, 0, 0.5);
set_line_width(cr, 10.0);
stroke(cr);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_rounded_rectangle.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);

## original example, following here

arc(cr, 128.0, 128.0, 76.8, 0, 2*pi);
clip(cr);
new_path(cr); # path not consumed by clip

image = read_from_png("data/mulberry.png"); # should be create_from_png
w = image.width;
h = image.height;

scale(cr, 256.0/w, 256.0/h);

set_source_surface(cr, image, 0, 0);
paint(cr);

#cairo_surface_destroy not used here

## mark picture with current date
restore(cr); 
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_clip_image.png");

## header to provide surface and context
using Cairo
using Colors

c = CairoRGBSurface(256,256)
cr = CairoContext(c)

save(cr)

z = Array{RGB24}(undef, 2, 2)
c1 = convert(RGB24,colorant"grey20")
c2 = convert(RGB24,colorant"grey80")
z[1,1] = c1
z[1,2] = c2
z[2,1] = c2
z[2,2] = c1

img = CairoImageSurface(z)
pattern = CairoPattern(img)
pattern_set_extend(pattern, Cairo.EXTEND_REPEAT)
pattern_set_filter(pattern, Cairo.FILTER_BILINEAR)

m = CairoMatrix(1/8.0,0,0,1/8.0,0,0)

set_matrix(pattern, m)
set_source(cr, pattern)
paint(cr)
restore(cr)

save(cr)

# 5 uses of set_source

# color
save(cr)
rectangle(cr,16,32,224,32)
set_source(cr, colorant"red4")
fill(cr)
restore(cr)

# color with alpha
save(cr)
rectangle(cr,16,72,224,32)
set_source(cr, alphacolor(colorant"blue",0.5))
fill(cr)
restore(cr)

# image from surface
save(cr)
rectangle(cr,16,112,224,32)
clip(cr)
new_path(cr)
s = read_from_png("data/mulberry.png")
set_source(cr,s)
paint_with_alpha(cr,0.6)
restore(cr)

# image from context (from surface)
save(cr)
rectangle(cr,16,152,224,32)
clip(cr)
new_path(cr)
set_source(cr,creategc(s))
paint(cr)
restore(cr)

# image for surface with offset
save(cr)
rectangle(cr,16,192,224,32)
clip(cr)
set_source(cr,s,0.0,40.0)
paint(cr)
restore(cr)



## mark picture with current date
restore(cr)
move_to(cr,0.0,12.0)
set_source_rgb(cr, 0,0,0)
show_text(cr,Libc.strftime(time()))
write_to_png(c,"sample_alpha_paint.png")

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, following here
move_to(cr, 128.0, 25.6);
line_to(cr, 230.4, 230.4);
rel_line_to(cr, -102.4, 0.0);
curve_to(cr, 51.2, 230.4, 51.2, 128.0, 128.0, 128.0);
close_path(cr);

move_to(cr, 64.0, 25.6);
rel_line_to(cr, 51.2, 51.2);
rel_line_to(cr, -51.2, 51.2);
rel_line_to(cr, -51.2, -51.2);
close_path(cr);

set_line_width(cr, 10.0);
set_source_rgb(cr, 0, 0, 1);
fill_preserve(cr);
set_source_rgb(cr, 0, 0, 0);
stroke(cr);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_fill_and_stroke2.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
# example, following here

inline_png2 = b"\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00d\x00\x00\x00d\x08\x02\x00\x00\x00\xff\x80\x02\x03\x00\x00\x00\x06bKGD\x00\xff\x00\xff\x00\xff\xa0\xbd\xa7\x93\x00\x00\x01=IDATx\x9c\xed\xdc\xc1i\x85@\x14@\xd1IH!\x96bi\x96f)\x96\x92E@!\x01\x7f\xeeF\xfdp\xce\xca\x9d\xc3\xe5\xb9{\xce\xc7\xb2,\x83\xff\xf9\xbc\xfb\x00\xefD\xac@\xac@\xac@\xac@\xac@\xac@\xac@\xac\xe0\xeb\xee\x03\xfc\xb1\xaec]\xc7\x18c\x9e\xc7<\xdf{\x96_LV V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V V\xf0j[\xf9gq\xf8J\xdbv<\\\xff\xf6\xd3\xfd\xe8\xe7\xc5\xdam\xdb\x11\xee2\xa7\xb1|\x86\xc1\xab\xc9\xba~m\x7f\x1f\xa8i\x1a\xd3t\xf5\xdbO=/\xd6\xba\x1e\xb1\xfca\xf1\xbe\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\xc4\n\x9ew\x1f\xfc\xf3\xae\x81\xdf\x99\xac@\xac@\xac@\xac@\xac@\xac@\xac@\xac@\xac\xe0\x1b\xaf\xef\x1c\xd4\x17\xfe\xcaX\x00\x00\x00\x00IEND\xaeB`\x82"
png_stream = IOBuffer();
write(png_stream,inline_png2);
seekstart(png_stream);

imagesurface = read_from_png(png_stream);
set_source_surface(cr, imagesurface, 0, 0);
paint(cr);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_imagestream.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, taken from cairo/test/pattern-mesh.c
function draw(cr, width::Int, height::Int)

	PAT_WIDTH  = 170
	PAT_HEIGHT = 170
	SIZE = PAT_WIDTH
	PAD = 2
	WIDTH = (PAD + SIZE + PAD)
	HEIGHT = WIDTH

	pattern = CairoPatternMesh();

	#cairo_test_paint_checkered (cr); ?

	translate(cr, PAD, PAD);
	translate(cr, 10, 10);

	mesh_pattern_begin_patch(pattern);

	mesh_pattern_move_to(pattern, 0, 0);
	mesh_pattern_curve_to(pattern, 30, -30,  60,  30, 100, 0);
	mesh_pattern_curve_to(pattern, 60,  30, 130,  60, 100, 100);
	mesh_pattern_curve_to(pattern, 60,  70,  30, 130,   0, 100);
	mesh_pattern_curve_to(pattern, 30,  70, -30,  30,   0, 0);

	mesh_pattern_set_corner_color_rgb(pattern, 0, 1, 0, 0);
	mesh_pattern_set_corner_color_rgb(pattern, 1, 0, 1, 0);
	mesh_pattern_set_corner_color_rgb(pattern, 2, 0, 0, 1);
	mesh_pattern_set_corner_color_rgb(pattern, 3, 1, 1, 0);

	mesh_pattern_end_patch(pattern);

	mesh_pattern_begin_patch(pattern);

	mesh_pattern_move_to(pattern, 50, 50);
	mesh_pattern_curve_to(pattern,  80,  20, 110,  80, 150, 50);
	mesh_pattern_curve_to(pattern, 110,  80, 180, 110, 150, 150);
	mesh_pattern_curve_to(pattern, 110, 120,  80, 180,  50, 150);
	mesh_pattern_curve_to(pattern,  80, 120,  20,  80,  50, 50);

	mesh_pattern_set_corner_color_rgba(pattern, 0, 1, 0, 0, 0.3);
	mesh_pattern_set_corner_color_rgb(pattern, 1, 0, 1, 0);
	mesh_pattern_set_corner_color_rgba(pattern, 2, 0, 0, 1, 0.3);
	mesh_pattern_set_corner_color_rgb(pattern, 3, 1, 1, 0);

	mesh_pattern_end_patch(pattern);

	set_source(cr, pattern);
	paint(cr);
	#pattern_destroy (pattern);

end

draw(cr,170,170);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_meshpattern.png");

module Cairo

import Base.Sys

# For libcairo
using Cairo_jll
# For libpangocairo
using Pango_jll
# For libgobject
using Glib_jll

# Deprecate old library variables
Base.@deprecate_binding _jl_libcairo      Cairo.libcairo   false
Base.@deprecate_binding _jl_libgobject    Cairo.libgobject false
Base.@deprecate_binding _jl_libpango      Cairo.libpango   false
Base.@deprecate_binding _jl_libpangocairo Cairo.libpango   false

using Colors

import Graphics
using Graphics: BoundingBox, GraphicsContext, GraphicsDevice
import Graphics: arc, clip, clip_preserve, close_path, creategc, device_to_user!, device_to_user_distance!, fill_preserve, height, line_to, move_to, new_path, new_sub_path, paint, rectangle, rel_line_to, rel_move_to, reset_clip, restore, rotate, save, scale, set_dash, set_line_width, set_source, set_source_rgb, set_source_rgba, stroke, stroke_preserve, stroke_transformed, stroke_transformed_preserve, textwidth, translate, user_to_device!, user_to_device_distance!, width, circle, reset_transform
import Base: copy, fill

libcairo_version = VersionNumber(unsafe_string(
      ccall((:cairo_version_string,Cairo.libcairo),Cstring,()) ))
libpango_version = VersionNumber(unsafe_string(
      ccall((:pango_version_string,Cairo.libpango),Cstring,()) ))
if !Sys.iswindows()
    libpangocairo_version = VersionNumber(unsafe_string(
          ccall((:pango_version_string,Cairo.libpangocairo),Cstring,()) ))
    libgobject_version = VersionNumber(
          unsafe_load(cglobal((:glib_major_version, Cairo.libgobject), Cuint)),
          unsafe_load(cglobal((:glib_minor_version, Cairo.libgobject), Cuint)),
          unsafe_load(cglobal((:glib_micro_version, Cairo.libgobject), Cuint)))
end

import Base.show

include("constants.jl")

export
    # drawing surface and context types
    CairoSurface, CairoContext, CairoPattern,

    # surface constructors
    CairoRGBSurface, CairoPDFSurface, CairoEPSSurface, CairoXlibSurface,
    CairoARGBSurface, CairoSVGSurface, CairoImageSurface, CairoQuartzSurface,
    CairoWin32Surface, CairoScriptSurface, CairoRecordingSurface,
    CairoPSSurface, surface_create_similar,

    # surface and context management
    finish, destroy, status, get_source,
    creategc, save, restore, show_page, copy_page, width, height,

    # pattern
    pattern_create_radial, pattern_create_linear,
    pattern_add_color_stop_rgb, pattern_add_color_stop_rgba,
    pattern_set_filter, pattern_set_extend, pattern_get_surface,

    # mesh patterns (version > 1.12)
    CairoPatternMesh,
    mesh_pattern_begin_patch, mesh_pattern_end_patch,
    mesh_pattern_move_to, mesh_pattern_line_to,
    mesh_pattern_curve_to,
    mesh_pattern_set_corner_color_rgb,
    mesh_pattern_set_corner_color_rgba,

    # drawing attribute manipulation
    set_antialias, get_antialias,
    set_fill_type, set_line_width, set_dash,
    set_source_rgb, set_source_rgba, set_source_surface, set_line_type,
    set_line_cap, set_line_join,
    set_operator, get_operator, set_source,
    CairoMatrix,

    # coordinate systems
    reset_transform, rotate, scale, translate, user_to_device!,
    device_to_user!, user_to_device_distance!, device_to_user_distance!,
    get_matrix, set_matrix,

    # clipping
    clip, clip_preserve, reset_clip,

    # fill, stroke, path, and shape commands
    fill, fill_preserve, new_path, new_sub_path, close_path, paint, paint_with_alpha, stroke,
    stroke_preserve, stroke_transformed, stroke_transformed_preserve,
    move_to, line_to, rel_line_to, rel_move_to,
    rectangle, circle, arc, arc_negative,
    curve_to, rel_curve_to,
    path_extents,

    # path copy
    copy_path, copy_path_flat, convert_cairo_path_data,

    # other path operations
    get_current_point, has_current_point,

    # text
    text,
    update_layout, show_layout, get_layout_size, layout_text,
    set_text, set_latex,
    set_font_face, set_font_size, select_font_face,
    textwidth, textheight, text_extents,
    TeXLexer, tex2pango, show_text, text_path,
    set_font_matrix, get_font_matrix,

    # images
    write_to_png, image, read_from_png,

    # push+pop group
    push_group, pop_group

## head docstring following

"
Surfaces, the canvas you are painting on

    CairoSurface, CairoRGBSurface, CairoPDFSurface, CairoEPSSurface,
    CairoXlibSurface, CairoARGBSurface, CairoSVGSurface,
    CairoImageSurface, CairoQuartzSurface,
    CairoWin32Surface, CairoScriptSurface, CairoRecordingSurface,
    CairoPSSurface,

Context, the handle to coordinate transformation, paint+Color

    CairoContext, finish, destroy, status, get_source,
    creategc, save, restore, show_page, copy_page, width, height

Path creation API

    new_path, new_sub_path, close_path,
    move_to, line_to, rel_line_to, rel_move_to,
    rectangle, circle, arc, arc_negative,
    curve_to, rel_curve_to,
    path_extents,


Stroking and painting API

    fill, fill_preserve, paint, paint_with_alpha, stroke,
    stroke_preserve, stroke_transformed, stroke_transformed_preserve

    CairoContext, finish, destroy, status, get_source,
    creategc, save, restore, show_page, copy_page, width, height

"
Cairo

function write_to_stream_callback(s::IO, buf::Ptr{UInt8}, len::UInt32)
    n = unsafe_write(s,buf,len)
    Int32((n == len) ? 0 : 11)
end

get_stream_callback(::Type{T}) where T = @cfunction write_to_stream_callback  Int32 (Ref{T}, Ptr{UInt8}, UInt32)

function read_from_stream_callback(s::IO, buf::Ptr{UInt8}, len::UInt32)
    # wrap the provided buf into a julia Array
    b1 = unsafe_wrap(Array,buf,len)

    # read from stream
    nb = readbytes!(s,b1,len)

    # provide a return status
    (nb == len) ? STATUS_SUCCESS : STATUS_READ_ERROR
end

get_readstream_callback(::Type{T}) where T = @cfunction read_from_stream_callback Int32 (Ref{T}, Ptr{UInt8}, UInt32)

abstract type CairoSurface{T<:Union{UInt32,RGB24,ARGB32}} <: GraphicsDevice end

# All CairoSurfaces have to implement at least the fields and types of CairoSurfaceBase
function Base.getproperty(surface::CairoSurface, fieldname::Symbol)
    if fieldname === :ptr
        return getfield(surface, :ptr)::Ptr{Nothing}
    elseif fieldname === :width
        return getfield(surface, :width)::Float64
    elseif fieldname === :height
        return getfield(surface, :height)::Float64
    end
    return getfield(surface, fieldname)
end

mutable struct CairoSurfaceBase{T<:Union{UInt32,RGB24,ARGB32}} <: CairoSurface{T}
    ptr::Ptr{Nothing}
    width::Float64
    height::Float64

    function CairoSurface{T}(ptr::Ptr{Nothing}, w, h) where {T}
        self = new{T}(ptr, w, h)
        finalizer(destroy, self)
        self
    end
    function CairoSurface{T}(ptr::Ptr{Nothing}) where {T}
        ccall(
          (:cairo_surface_reference,libcairo),
          Ptr{Nothing}, (Ptr{Nothing}, ), ptr)
        self = new{T}(ptr)
        finalizer(destroy, self)
        self
    end
end


mutable struct CairoSurfaceImage{T<:Union{UInt32,RGB24,ARGB32}} <: CairoSurface{T}
    ptr::Ptr{Nothing}
    width::Float64
    height::Float64
    data::Matrix{T}

    function CairoSurface{T}(ptr::Ptr{Nothing}, w, h, data::Matrix{T}) where {T}
        self = new{T}(ptr, w, h, data)
        finalizer(destroy, self)
        self
    end
end

mutable struct CairoSurfaceIOStream{T<:Union{UInt32,RGB24,ARGB32}} <: CairoSurface{T}
    ptr::Ptr{Nothing}
    width::Float64
    height::Float64
    stream::IO

    function CairoSurface{T}(ptr::Ptr{Nothing}, w, h, stream::IO) where {T}
        self = new{T}(ptr, w, h, stream)
        finalizer(destroy, self)
        self
    end
end
function get_stream_ptr(surf::T) where {T<:CairoSurfaceIOStream}
    GC.@preserve surf begin
        return unsafe_load(Ptr{Ptr{Nothing}}(pointer_from_objref(surf) + fieldoffset(T, 4)))
    end
end


CairoSurface(ptr, w, h) = CairoSurface{UInt32}(ptr, w, h)
CairoSurface(ptr, w, h, data) = CairoSurface{eltype(data)}(ptr, w, h, data)
CairoSurface(ptr, w, h, stream::IO) = CairoSurface{UInt32}(ptr, w, h, stream)
CairoSurface(ptr) = CairoSurface{UInt32}(ptr)

width(surface::CairoSurface) = surface.width
height(surface::CairoSurface) = surface.height

function destroy(surface::CairoSurface)
    if surface.ptr == C_NULL
        return
    end
    ccall((:cairo_surface_destroy,libcairo), Nothing, (Ptr{Nothing},), surface.ptr)
    surface.ptr = C_NULL
    nothing
end

# function resize(surface::CairoSurface, w, h)
#     if OS_NAME == :Linux
#         CairoXlibSurfaceSetSize(surface.ptr, w, h)
#     elseif OS_NAME == :Darwin
#     elseif OS_NAME == :Windows
#     else
#         error("Unsupported operating system")
#     end
#     surface.width = w
#     surface.height = h
# end

for name in (:finish,:flush,:mark_dirty)
    @eval begin
        $name(surface::CairoSurface) =
            ccall(($(string("cairo_surface_",name)),libcairo),
                  Nothing, (Ptr{Nothing},), surface.ptr)
    end
end

function image_surface_get_data(surface::CairoSurface{T}) where {T}
    return ccall(
        (:cairo_image_surface_get_data, libcairo),
        Ptr{T}, (Ptr{Nothing},), surface.ptr)
end

function status(surface::CairoSurface)
    ccall((:cairo_surface_status,libcairo),
          Int32, (Ptr{Nothing},), surface.ptr)
end

function CairoImageSurface(w::Real, h::Real, format::Integer)
    ptr = ccall((:cairo_image_surface_create,libcairo),
                Ptr{Nothing}, (Int32,Int32,Int32), format, w, h)
    CairoSurface(ptr, w, h)
end

CairoRGBSurface(w::Real, h::Real) = CairoImageSurface(w, h, FORMAT_RGB24)
CairoARGBSurface(w::Real, h::Real) = CairoImageSurface(w, h, FORMAT_ARGB32)
CairoARGBSurface(img) = CairoImageSurface(img, FORMAT_ARGB32)
CairoRGBSurface(img) = CairoImageSurface(img, FORMAT_RGB24)

function CairoImageSurface(img::Array{UInt32,2}, format::Integer; flipxy::Bool = true)
    if flipxy
        img = permutedims(img, (2,1))
    end
    w,h = size(img)
    stride = format_stride_for_width(format, w)
    @assert stride == 4w
    ptr = ccall((:cairo_image_surface_create_for_data,libcairo),
                Ptr{Nothing}, (Ptr{Nothing},Int32,Int32,Int32,Int32),
                img, format, w, h, stride)
    CairoSurface(ptr, w, h, img)
end

function CairoImageSurface(img::Matrix{T}) where {T<:Union{RGB24,ARGB32}}
    w,h = size(img)
    stride = format_stride_for_width(format(T), w)
    @assert stride == 4w
    ptr = ccall((:cairo_image_surface_create_for_data,libcairo),
                Ptr{Nothing}, (Ptr{Nothing},Int32,Int32,Int32,Int32),
                img, format(T), w, h, stride)
    CairoSurface(ptr, w, h, img)
end

format(::Type{RGB24}) = FORMAT_RGB24
format(::Type{ARGB32}) = FORMAT_ARGB32
format(surf::CairoSurface{T}) where {T<:Union{RGB24,ARGB32}} = T

## PDF ##

function CairoPDFSurface(stream::T, w::Real, h::Real) where {T<:IO}
    callback = get_stream_callback(T)
    surf = CairoSurface(C_NULL, w, h, stream)
    GC.@preserve surf begin
        surf.ptr = ccall((:cairo_pdf_surface_create_for_stream,libcairo), Ptr{Nothing},
                         (Ptr{Nothing}, Ptr{Nothing}, Float64, Float64), callback,
                         get_stream_ptr(surf), w, h)
    end
    return surf
end

function CairoPDFSurface(filename::AbstractString, w_pts::Real, h_pts::Real)
    ptr = ccall((:cairo_pdf_surface_create,libcairo), Ptr{Nothing},
                (Ptr{UInt8},Float64,Float64), String(filename), w_pts, h_pts)
    CairoSurface(ptr, w_pts, h_pts)
end

## EPS ##

function CairoEPSSurface(stream::T, w::Real, h::Real) where {T<:IO}
    callback = get_stream_callback(T)
    surf = CairoSurface(C_NULL, w, h, stream)
    GC.@preserve surf begin
        surf.ptr = ccall((:cairo_ps_surface_create_for_stream,libcairo), Ptr{Nothing},
                         (Ptr{Nothing}, Ptr{Nothing}, Float64, Float64),
                         callback, get_stream_ptr(surf), w, h)
        ccall((:cairo_ps_surface_set_eps,libcairo), Nothing,
              (Ptr{Nothing},Int32), surf.ptr, 1)
    end
    return surf
end

function CairoEPSSurface(filename::AbstractString, w_pts::Real, h_pts::Real)
    ptr = ccall((:cairo_ps_surface_create,libcairo), Ptr{Nothing},
                (Ptr{UInt8},Float64,Float64), String(filename), w_pts, h_pts)
    ccall((:cairo_ps_surface_set_eps,libcairo), Nothing,
          (Ptr{Nothing},Int32), ptr, 1)
    CairoSurface(ptr, w_pts, h_pts)
end

## PS ##

function CairoPSSurface(stream::T, w::Real, h::Real) where {T<:IO}
    callback = get_stream_callback(T)
    surf = CairoSurface(C_NULL, w, h, stream)
    GC.@preserve surf begin
        surf.ptr = ccall((:cairo_ps_surface_create_for_stream,libcairo), Ptr{Nothing},
                         (Ptr{Nothing}, Ptr{Nothing}, Float64, Float64),
                         callback, get_stream_ptr(surf), w, h)
        ccall((:cairo_ps_surface_set_eps,libcairo), Nothing,
              (Ptr{Nothing},Int32), surf.ptr, 0)
    end
    return surf
end

function CairoPSSurface(filename::AbstractString, w_pts::Real, h_pts::Real)
    ptr = ccall((:cairo_ps_surface_create,libcairo), Ptr{Nothing},
                (Ptr{UInt8},Float64,Float64), String(filename), w_pts, h_pts)
    ccall((:cairo_ps_surface_set_eps,libcairo), Nothing,
          (Ptr{Nothing},Int32), ptr, 0)
    CairoSurface(ptr, w_pts, h_pts)
end

## Xlib ##

function CairoXlibSurface(display, drawable, visual, w, h)
    ptr = ccall((:cairo_xlib_surface_create,libcairo), Ptr{Nothing},
                (Ptr{Nothing}, Int, Ptr{Nothing}, Int32, Int32),
                display, drawable, visual, w, h)
    CairoSurface(ptr, w, h)
end

CairoXlibSurfaceSetSize(surface, w, h) =
    ccall((:cairo_xlib_surface_set_size,libcairo), Nothing,
          (Ptr{Nothing}, Int32, Int32),
          surface, w, h)

## Quartz ##
function CairoQuartzSurface(context, w, h)
    ptr = ccall((:cairo_quartz_surface_create_for_cg_context,libcairo),
          Ptr{Nothing}, (Ptr{Nothing}, UInt32, UInt32), context, w, h)
    CairoSurface(ptr, w, h)
end

## Win32 ##

function CairoWin32Surface(hdc,w,h)
    ptr = ccall((:cairo_win32_surface_create, libcairo),
                Ptr{Nothing}, (Ptr{Nothing},), hdc)
    CairoSurface(ptr,w,h)
end

## SVG ##

function CairoSVGSurface(stream::T, w::Real, h::Real) where {T<:IO}
    callback = get_stream_callback(T)
    surf = CairoSurface(C_NULL, w, h, stream)
    GC.@preserve surf begin
        surf.ptr = ccall((:cairo_svg_surface_create_for_stream,libcairo), Ptr{Nothing},
                         (Ptr{Nothing}, Ptr{Nothing}, Float64, Float64), callback,
                         get_stream_ptr(surf), w, h)
    end
    return surf
end

function CairoSVGSurface(filename::AbstractString, w::Real, h::Real)
    ptr = ccall((:cairo_svg_surface_create,libcairo), Ptr{Nothing},
                (Ptr{UInt8},Float64,Float64), String(filename), w, h)
    CairoSurface(ptr, w, h)
end

## PNG ##

function read_from_png(filename::AbstractString)
    ptr = ccall((:cairo_image_surface_create_from_png,libcairo),
                Ptr{Nothing}, (Ptr{UInt8},), String(filename))
    w = ccall((:cairo_image_surface_get_width,libcairo),
              Int32, (Ptr{Nothing},), ptr)
    h = ccall((:cairo_image_surface_get_height,libcairo),
              Int32, (Ptr{Nothing},), ptr)
    CairoSurface(ptr, w, h)
end

function write_to_png(surface::CairoSurface, stream::T) where {T<:IO}
    callback = get_stream_callback(T)
    ccall((:cairo_surface_write_to_png_stream,libcairo), status_t,
          (Ptr{UInt8},Ptr{Nothing},Any), surface.ptr, callback, stream)
end

function write_to_png(surface::CairoSurface, filename::AbstractString)
    ccall((:cairo_surface_write_to_png,libcairo), status_t,
          (Ptr{UInt8},Ptr{UInt8}), surface.ptr, String(filename))
end

show(io::IO, ::MIME"image/png", surface::CairoSurface) =
   write_to_png(surface, io)

function read_from_png(stream::T) where {T<:IO}
    callback = get_readstream_callback(T)
    ptr = ccall((:cairo_image_surface_create_from_png_stream, Cairo.libcairo),
                Ptr{Nothing}, (Ptr{Nothing},Ref{IO}), callback, stream)
    w = ccall((:cairo_image_surface_get_width,Cairo.libcairo),
              Int32, (Ptr{Nothing},), ptr)
    h = ccall((:cairo_image_surface_get_height,Cairo.libcairo),
              Int32, (Ptr{Nothing},), ptr)
    Cairo.CairoSurface(ptr, w, h)
end


## Generic ##

function surface_create_similar(s::CairoSurface, w = width(s), h = height(s))
    ptr = ccall((:cairo_surface_create_similar,libcairo), Ptr{Nothing},
                (Ptr{Nothing}, Int32, Int32, Int32),
                s.ptr, CONTENT_COLOR_ALPHA, w, h)
    CairoSurface(ptr, w, h)
end

# Utilities

function format_stride_for_width(format::Integer, width::Integer)
    ccall((:cairo_format_stride_for_width,libcairo), Int32,
          (Int32,Int32), format, width)
end


## Scripting (only target IO stream)

mutable struct CairoScript <: GraphicsDevice
    ptr::Ptr{Nothing}
    stream::IO

    function CairoScript(stream::T) where {T<:IO}
        callback = get_stream_callback(T)
        self = new(C_NULL, stream)
        GC.@preserve self begin
            self.ptr = ccall((:cairo_script_create_for_stream,libcairo), Ptr{Nothing},
                             (Ptr{Nothing}, Ptr{Nothing}), callback, get_stream_ptr(self))
        end
        finalizer(destroy, self)
        self
    end
end
function get_stream_ptr(s::T) where {T<:CairoScript}
    GC.@preserve s begin
        return unsafe_load(Ptr{Ptr{Nothing}}(pointer_from_objref(s) + fieldoffset(T, 2)))
    end
end

function destroy(s::CairoScript)
    if s.ptr == C_NULL
        return
    end
    ccall((:cairo_device_destroy,libcairo), Nothing, (Ptr{Nothing},), s.ptr)
    s.ptr = C_NULL
    nothing
end

function CairoScriptSurface(stream::IO, w::Real, h::Real)
    s = CairoScript(stream)
    ptr = ccall((:cairo_script_surface_create,libcairo), Ptr{Nothing},
                (Ptr{Nothing},Int32,Float64,Float64),s.ptr ,CONTENT_COLOR_ALPHA, w, h)
    CairoSurface(ptr, w, h, stream)
end

function CairoScriptSurface(stream::IO, sc::CairoSurface)
    s = CairoScript(stream)
    ptr = ccall((:cairo_script_surface_create_for_target,libcairo), Ptr{Nothing},
                (Ptr{Nothing},Ptr{Nothing}),s.ptr, sc.ptr)
    CairoSurface(ptr, sc.width, sc.height)
end



mutable struct CairoRectangle
    x0::Float64
    y0::Float64
    x1::Float64
    y1::Float64
end

CairoRectangle() = CairoRectangle(0.0, 0.0, 0.0, 0.0)

function CairoRecordingSurface(content::Int32,extents::CairoRectangle)
    ptr = ccall((:cairo_recording_surface_create,libcairo), Ptr{Nothing},
                (Int32,Ptr{Nothing}),content, Ref(extents))
    CairoSurface(ptr)
end
function CairoRecordingSurface(content::Int32)
    ptr = ccall((:cairo_recording_surface_create,libcairo), Ptr{Nothing},
                (Int32,Ptr{Nothing}),content, C_NULL)
    CairoSurface(ptr)
end

CairoRecordingSurface() = CairoRecordingSurface(CONTENT_COLOR_ALPHA)


function script_from_recording_surface(s::CairoScript,r::CairoSurface)
    ccall((:cairo_script_from_recording_surface,libcairo), Int32,
                (Ptr{Nothing},Ptr{Nothing}),s.ptr, r.ptr)
end
# -----------------------------------------------------------------------------

mutable struct CairoContext <: GraphicsContext
    ptr::Ptr{Nothing}
    surface::CairoSurface
    layout::Ptr{Nothing} # cache PangoLayout

    function CairoContext(surface::CairoSurface)
        ptr = ccall((:cairo_create,libcairo),
                    Ptr{Nothing}, (Ptr{Nothing},), surface.ptr)
        layout = ccall((:pango_cairo_create_layout,libpangocairo),
                       Ptr{Nothing}, (Ptr{Nothing},), ptr)
        self = new(ptr, surface, layout)
        finalizer(destroy, self)
        self
    end
    function CairoContext(ptr::Ptr{Nothing})
        ccall((:cairo_reference,libcairo),
                   Ptr{Nothing}, (Ptr{Nothing},), ptr)
        surface_p = ccall((:cairo_get_target,libcairo),
                   Ptr{Nothing}, (Ptr{Nothing},), ptr)
        surface = CairoSurface(surface_p)
        layout = ccall((:pango_cairo_create_layout,libpangocairo),
                  Ptr{Nothing}, (Ptr{Nothing},), ptr)
        self = new(ptr,surface,layout)
        finalizer(destroy, self)
        self
    end


end

creategc(s::CairoSurface) = CairoContext(s)

function destroy(ctx::CairoContext)
    if ctx.ptr == C_NULL
        return
    end
    ccall((:g_object_unref,libgobject), Nothing, (Ptr{Nothing},), ctx.layout)
    _destroy(ctx)
    ctx.ptr = C_NULL
    nothing
end

 width(ctx::CairoContext) =  width(ctx.surface)
height(ctx::CairoContext) = height(ctx.surface)

function copy(ctx::CairoContext)
    surf = surface_create_similar(ctx.surface)
    c = creategc(surf)
    set_source_surface(c, ctx.surface)
    paint(c)
    set_matrix(c, get_matrix(ctx))
    c
end

# Copy a rectangular region
function copy(ctx::CairoContext, bb::BoundingBox)
    w = width(bb)
    h = height(bb)
    surf = surface_create_similar(ctx.surface, ceil(Int,w), ceil(Int,h))
    c = creategc(surf)
    set_source_surface(c, ctx.surface, -bb.xmin, -bb.ymin)
    rectangle(c, 0, 0, w, h)
    fill(c)
    set_matrix(c, get_matrix(ctx))
    c
end

for (NAME, FUNCTION) in Any[(:_destroy, :cairo_destroy),
                         (:save, :cairo_save),
                         (:restore, :cairo_restore),
                         (:show_page, :cairo_show_page),
                         (:copy_page, :cairo_copy_page),
                         (:clip, :cairo_clip),
                         (:clip_preserve, :cairo_clip_preserve),
                         (:reset_clip, :cairo_reset_clip),
                         (:reset_transform, :cairo_identity_matrix),
                         (:fill, :cairo_fill),
                         (:fill_preserve, :cairo_fill_preserve),
                         (:new_path, :cairo_new_path),
                         (:new_sub_path, :cairo_new_sub_path),
                         (:close_path, :cairo_close_path),
                         (:paint, :cairo_paint),
                         (:stroke_transformed, :cairo_stroke),
                         (:stroke_transformed_preserve, :cairo_stroke_preserve)]
    @eval begin
        $NAME(ctx::CairoContext) =
            ccall(($(Expr(:quote,FUNCTION)),libcairo),
                  Nothing, (Ptr{Nothing},), ctx.ptr)
    end
end

function stroke(ctx::CairoContext)
    save(ctx)
    # use uniform scale for stroking
    reset_transform(ctx)
    ccall((:cairo_stroke, libcairo), Nothing, (Ptr{Nothing},), ctx.ptr)
    restore(ctx)
end

function stroke_preserve(ctx::CairoContext)
    save(ctx)
    reset_transform(ctx)
    ccall((:cairo_stroke_preserve, libcairo), Nothing, (Ptr{Nothing},), ctx.ptr)
    restore(ctx)
end

function paint_with_alpha(ctx::CairoContext, a)
    ccall((:cairo_paint_with_alpha, libcairo),
          Nothing, (Ptr{Nothing}, Float64), ctx.ptr, a)
end

function get_operator(ctx::CairoContext)
    Int(ccall((:cairo_get_operator,libcairo), Int32, (Ptr{Nothing},), ctx.ptr))
end


for (NAME, FUNCTION) in Any[(:set_fill_type, :cairo_set_fill_rule),
                         (:set_operator, :cairo_set_operator),
                         (:set_line_cap, :cairo_set_line_cap),
                         (:set_line_join, :cairo_set_line_join)]
    @eval begin
        $NAME(ctx::CairoContext, i0::Integer) =
            ccall(($(Expr(:quote,FUNCTION)),libcairo),
                  Nothing, (Ptr{Nothing},Int32), ctx.ptr, i0)
    end
end

for (NAME, FUNCTION) in Any[(:set_line_width, :cairo_set_line_width),
                         (:rotate, :cairo_rotate),
                         (:set_font_size, :cairo_set_font_size)]
    @eval begin
        $NAME(ctx::CairoContext, d0::Real) =
            ccall(($(Expr(:quote,FUNCTION)),libcairo),
                  Nothing, (Ptr{Nothing},Float64), ctx.ptr, d0)
    end
end

for (NAME, FUNCTION) in Any[(:line_to, :cairo_line_to),
                         (:move_to, :cairo_move_to),
                         (:rel_line_to, :cairo_rel_line_to),
                         (:rel_move_to, :cairo_rel_move_to),
                         (:scale, :cairo_scale),
                         (:translate, :cairo_translate)]
    @eval begin
        $NAME(ctx::CairoContext, d0::Real, d1::Real) =
            ccall(($(Expr(:quote,FUNCTION)),libcairo),
                  Nothing, (Ptr{Nothing},Float64,Float64), ctx.ptr, d0, d1)
    end
end

for (NAME, FUNCTION) in Any[(:curve_to, :cairo_curve_to),
                         (:rel_curve_to, :cairo_rel_curve_to)]
    @eval begin
        $NAME(ctx::CairoContext, d0::Real, d1::Real, d2::Real, d3::Real, d4::Real, d5::Real) =
            ccall(($(Expr(:quote,FUNCTION)),libcairo),
                  Nothing, (Ptr{Nothing},Float64,Float64,Float64,Float64,Float64,Float64), ctx.ptr, d0, d1, d2, d3, d4, d5)
    end
end

for (NAME, FUNCTION) in Any[(:arc, :cairo_arc),
                         (:arc_negative, :cairo_arc_negative)]
    @eval begin
        $NAME(ctx::CairoContext, xc::Real, yc::Real, radius::Real, angle1::Real, angle2::Real) =
            ccall(($(Expr(:quote,FUNCTION)),libcairo),
                  Nothing, (Ptr{Nothing},Float64,Float64,Float64,Float64,Float64),
                  ctx.ptr, xc, yc, radius, angle1, angle2)
    end
end


set_source_rgb(ctx::CairoContext, r::Real, g::Real, b::Real) =
    ccall((:cairo_set_source_rgb,libcairo),
          Nothing, (Ptr{Nothing},Float64,Float64,Float64), ctx.ptr, r, g, b)

set_source_rgba(ctx::CairoContext, r::Real, g::Real, b::Real, a::Real) =
    ccall((:cairo_set_source_rgba,libcairo), Nothing,
          (Ptr{Nothing},Float64,Float64,Float64,Float64),
          ctx.ptr, r, g, b, a)

function set_source(ctx::CairoContext, c::Color)
    rgb = convert(RGB, c)
    set_source_rgb(ctx, rgb.r, rgb.g, rgb.b)
end

function set_source(ctx::CairoContext, ac::TransparentColor)
    rgba = convert(RGBA, ac)
    set_source_rgba(ctx, rgba.r, rgba.g, rgba.b, rgba.alpha)
end

set_source(dest::CairoContext, src::CairoContext) = set_source_surface(dest, src.surface)

set_source(dest::CairoContext, src::CairoSurface) = set_source_surface(dest, src)

rectangle(ctx::CairoContext, x::Real, y::Real, w::Real, h::Real) =
    ccall((:cairo_rectangle,libcairo), Nothing,
          (Ptr{Nothing},Float64,Float64,Float64,Float64),
          ctx.ptr, x, y, w, h)

function set_dash(ctx::CairoContext, dashes::Vector{Float64}, offset::Real = 0.0)
    ccall((:cairo_set_dash,libcairo), Nothing,
          (Ptr{Nothing},Ptr{Float64},Int32,Float64), ctx.ptr, dashes, length(dashes), offset)
end

function set_source_surface(ctx::CairoContext, s::CairoSurface, x::Real = 0.0, y::Real = 0.0)
    ccall((:cairo_set_source_surface,libcairo), Nothing,
          (Ptr{Nothing},Ptr{Nothing},Float64,Float64), ctx.ptr, s.ptr, x, y)
end

function set_source(ctx::CairoContext, s::CairoSurface, x::Real, y::Real)
    set_source_surface(ctx, s, x, y)
end


# cairo_path data and functions

mutable struct CairoPath_t
    status::Cairo.status_t
    data::Ptr{Float64}
    num_data::UInt32
end

mutable struct CairoPath <: GraphicsDevice
    ptr::Ptr{CairoPath_t}

    function CairoPath(ptr::Ptr{Nothing})
        self = new(ptr)
        finalizer(destroy, self)
        self
    end
end

# Abstract, contains type (moveto,lineto,curveto,closepath) and points
mutable struct CairoPathEntry
    element_type::UInt32
    points::Array{Float64,1}
end


function destroy(path::CairoPath)
    if path.ptr == C_NULL
        return
    end
    ccall((:cairo_path_destroy,libcairo), Nothing, (Ptr{Nothing},), path.ptr)
    path.ptr = C_NULL
    nothing
end

function copy_path(ctx::CairoContext)
    ptr = ccall((:cairo_copy_path, libcairo),
                    Ptr{Nothing}, (Ptr{Nothing},),ctx.ptr)
    path = CairoPath(ptr)
    finalizer(destroy, path)
    path
end

function copy_path_flat(ctx::CairoContext)
    ptr = ccall((:cairo_copy_path_flat, libcairo),
                    Ptr{Nothing}, (Ptr{Nothing},),ctx.ptr)
    path = CairoPath(ptr)
    finalizer(destroy, path)
    path
end

function convert_cairo_path_data(p::CairoPath)
    c = unsafe_load(p.ptr)

    # The original data (pointed by c.data) is an array of Unions. We
    # define here by Float64 (most data is) and reinterpret in the header.

    path_data = CairoPathEntry[]
    @static if VERSION >= v"0.7"
        c_data = unsafe_wrap(Array, c.data, (Int(c.num_data*2), 1), own=false)
    else
        c_data = unsafe_wrap(Array, c.data, (Int(c.num_data*2), 1), false)
    end

    data_index = 1
    while data_index <= ((c.num_data)*2)

        # read header (reinterpret a Float64 to UInt64 and split to UInt32 x 2)
        element_length = reinterpret(UInt64,c_data[data_index]) >> 32
        element_type = reinterpret(UInt64,c_data[data_index]) & 0xffffffff

        # copy points x,y
        points = Vector{Float64}(undef, (element_length - 1) * 2)
        for i=1:(element_length-1)*2
            points[i] = c_data[data_index+i+1]
        end

        g = CairoPathEntry(element_type,points)
        push!(path_data,g)

        # goto next element
        data_index += (element_length*2)

    end
    path_data
end

# other path operations

function get_current_point(ctx::CairoContext)

    x = Ref{Cdouble}(0)
    y = Ref{Cdouble}(0)
    ccall((:cairo_get_current_point, libcairo),
            Nothing, (Ptr{Nothing},Ref{Cdouble},Ref{Cdouble}),ctx.ptr,x,y)

    x[],y[]
end

function has_current_point(ctx::CairoContext)
    Bool(ccall((:cairo_has_current_point, libcairo),
            Cint, (Ptr{Nothing},),ctx.ptr))
end

# user<->device coordinate translation

for (fname,cname) in ((:user_to_device!,:cairo_user_to_device),
                      (:device_to_user!,:cairo_device_to_user),
                      (:user_to_device_distance!,:cairo_user_to_device_distance),
                      (:device_to_user_distance!,:cairo_device_to_user_distance))
    @eval begin
        function ($fname)(ctx::CairoContext, p::Vector{Float64})
            ccall(($(Expr(:quote,cname)),libcairo),
                  Nothing, (Ptr{Nothing}, Ptr{Float64}, Ptr{Float64}),
                  ctx.ptr, Ref(p,1), Ref(p,2))
            p
        end
    end
end

function image(ctx::CairoContext, s::CairoSurface, x, y, w, h)
    rectangle(ctx, x, y, w, h)
    save(ctx)
    translate(ctx, x, y)
    scale(ctx, w/s.width, h/s.height)
    set_source_surface(ctx, s, 0, 0)
    if abs(w) > s.width && abs(h) > s.height
        # use NEAREST filter when stretching an image
        # it's usually better to see pixels than a blurry mess when viewing
        # a small image
        p = get_source(ctx)
        pattern_set_filter(p, FILTER_NEAREST)
    end
    fill(ctx)
    restore(ctx)
end

image(ctx::CairoContext, img::Array{UInt32,2}, x, y, w, h) =
    image(ctx, CairoRGBSurface(img), x, y, w, h)

function push_group(ctx::CairoContext)
    if ctx.ptr == C_NULL
        return
    end
    ccall((:cairo_push_group, libcairo), Nothing, (Ptr{Nothing},),ctx.ptr)
    nothing
end

function pop_group(ctx::CairoContext)
    if ctx.ptr == C_NULL
        return
    end
    ptr = ccall((:cairo_pop_group, libcairo), Ptr{Nothing}, (Ptr{Nothing},),ctx.ptr)
    pattern = CairoPattern(ptr)
    finalizer(destroy, pattern)
    pattern
end

# -----------------------------------------------------------------------------

mutable struct CairoPattern
    ptr::Ptr{Nothing}
end

function CairoPattern(s::CairoSurface)
    ptr = ccall((:cairo_pattern_create_for_surface, libcairo),
                    Ptr{Nothing}, (Ptr{Nothing},), s.ptr)
    # Ideally we'd check the status, but at least for certain releases of the library
    # the return value seems not to be set properly (random values are returned)
#     status = ccall((:cairo_pattern_status, libcairo),
#                     Cint, (Ptr{Nothing},), s.ptr)
#     if status != 0
#         error("Error creating Cairo pattern: ", bytestring(
#               ccall((:cairo_status_to_string, libcairo),
#                     Ptr{UInt8}, (Cint,), status)))
#     end
    pattern = CairoPattern(ptr)
    finalizer(destroy, pattern)
    pattern
end

set_source(dest::CairoContext, src::CairoPattern) =
    ccall((:cairo_set_source, libcairo),
          Nothing, (Ptr{Nothing}, Ptr{Nothing}), dest.ptr, src.ptr)

function get_source(ctx::CairoContext)
    CairoPattern(ccall((:cairo_get_source,libcairo),
                       Ptr{Nothing}, (Ptr{Nothing},), ctx.ptr))
end

function pattern_set_filter(p::CairoPattern, f)
    ccall((:cairo_pattern_set_filter,libcairo), Nothing,
          (Ptr{Nothing},Int32), p.ptr, f)
end

function pattern_set_extend(p::CairoPattern, val)
    ccall((:cairo_pattern_set_extend,libcairo), Nothing,
          (Ptr{Nothing},Int32), p.ptr, val)
end

function pattern_create_radial(cx0::Real, cy0::Real, radius0::Real, cx1::Real, cy1::Real, radius1::Real)
    ptr = ccall((:cairo_pattern_create_radial, libcairo),
                    Ptr{Nothing}, (Float64,Float64,Float64,Float64,Float64,Float64),cx0,cy0,radius0,cx1,cy1,radius1)
    pattern = CairoPattern(ptr)
    finalizer(destroy, pattern)
    pattern
end

function pattern_create_linear(x0::Real, y0::Real, x1::Real, y1::Real)
    ptr = ccall((:cairo_pattern_create_linear, libcairo),
                    Ptr{Nothing}, (Float64,Float64,Float64,Float64),x0,y0,x1,y1)
    pattern = CairoPattern(ptr)
    finalizer(destroy, pattern)
    pattern
end

function pattern_add_color_stop_rgb(pat::CairoPattern, offset::Real, red::Real, green::Real, blue::Real)
    ccall((:cairo_pattern_add_color_stop_rgb, libcairo),
                    Nothing, (Ptr{Nothing},Float64,Float64,Float64,Float64),pat.ptr,offset,red,green,blue)
end

function pattern_add_color_stop_rgba(pat::CairoPattern, offset::Real, red::Real, green::Real, blue::Real, alpha::Real)
    ccall((:cairo_pattern_add_color_stop_rgba, libcairo),
                    Nothing, (Ptr{Nothing},Float64,Float64,Float64,Float64,Float64),pat.ptr,offset,red,green,blue,alpha)
end

function pattern_get_surface(pat::CairoPattern)
    ptrref = Ref{Ptr{Nothing}}()
    status = ccall((:cairo_pattern_get_surface, libcairo), Cint,
                   (Ptr{Nothing}, Ref{Ptr{Nothing}}), pat.ptr, ptrref)
    if status == STATUS_PATTERN_TYPE_MISMATCH
        error("Cannot get surface from a non-surface pattern.")
    end
    ptr = ptrref.x

    ccall((:cairo_surface_reference, libcairo), Ptr{Nothing}, (Ptr{Nothing},), ptr)
    typ = ccall((:cairo_surface_get_type, libcairo), Cint, (Ptr{Nothing},), ptr)

    w = 0.0
    h = 0.0
    if typ == CAIRO_SURFACE_TYPE_IMAGE
        w = ccall((:cairo_image_surface_get_width, libcairo),
                  Int32, (Ptr{Nothing},), ptr)
        h = ccall((:cairo_image_surface_get_height, libcairo),
                  Int32, (Ptr{Nothing},), ptr)
    end
    return CairoSurface(ptr, w, h)
end

function destroy(pat::CairoPattern)
    if pat.ptr == C_NULL
        return
    end
    ccall((:cairo_pattern_destroy,libcairo), Nothing, (Ptr{Nothing},), pat.ptr)
    pat.ptr = C_NULL
    nothing
end

# mesh pattern

# create mesh pattern
function CairoPatternMesh()
    ptr = ccall((:cairo_pattern_create_mesh, libcairo),
                    Ptr{Nothing}, ())
    pattern = CairoPattern(ptr)
    #status = ccall((:cairo_pattern_status, libcairo),
    #                Cint, (Ptr{Nothing},), pattern.ptr)
    #if status != 0
    #    error("Error creating Cairo pattern: ", bytestring(
    #          ccall((:cairo_status_to_string, libcairo),
    #                Ptr{Uint8}, (Cint,), status)))
    #end
    finalizer(destroy, pattern)
    pattern
end

#for (NAME, FUNCTION) in Any[(:set_line_width, :cairo_set_line_width),
#                         (:rotate, :cairo_rotate),
#                         (:set_font_size, :cairo_set_font_size)]
#    @eval begin
#        $NAME(ctx::CairoContext, d0::Real) =
#            ccall(($(Expr(:quote,FUNCTION)),libcairo),
#                  Nothing, (Ptr{Nothing},Float64), ctx.ptr, d0)
#    end
#end

for (NAME, FUNCTION) in Any[(:mesh_pattern_begin_patch, :cairo_mesh_pattern_begin_patch),
                         (:mesh_pattern_end_patch, :cairo_mesh_pattern_end_patch)]
    @eval begin
        $NAME(pattern::CairoPattern) =
            ccall(($(Expr(:quote,FUNCTION)),libcairo),
                  Nothing, (Ptr{Nothing},), pattern.ptr)
    end
end

for (NAME, FUNCTION) in Any[(:mesh_pattern_line_to, :cairo_mesh_pattern_line_to),
                         (:mesh_pattern_move_to, :cairo_mesh_pattern_move_to)]
    @eval begin
        $NAME(pattern::CairoPattern, d0::Real, d1::Real) =
            ccall(($(Expr(:quote,FUNCTION)),libcairo),
                  Nothing, (Ptr{Nothing},Float64,Float64), pattern.ptr, d0, d1)
    end
end

for (NAME, FUNCTION) in Any[(:mesh_pattern_curve_to, :cairo_mesh_pattern_curve_to)]

    @eval begin
        $NAME(pattern::CairoPattern, d0::Real, d1::Real, d2::Real, d3::Real, d4::Real, d5::Real) =
            ccall(($(Expr(:quote,FUNCTION)),libcairo),
                  Nothing, (Ptr{Nothing},Float64,Float64,Float64,Float64,Float64,Float64), pattern.ptr, d0, d1, d2, d3, d4, d5)
    end
end


function mesh_pattern_set_corner_color_rgb(pat::CairoPattern, corner_num::Real, red::Real, green::Real, blue::Real)
    ccall((:cairo_mesh_pattern_set_corner_color_rgb, libcairo),
                    Nothing, (Ptr{Nothing},Int32,Float64,Float64,Float64),pat.ptr,corner_num,red,green,blue)
end

function mesh_pattern_set_corner_color_rgba(pat::CairoPattern, corner_num::Real, red::Real, green::Real, blue::Real, alpha::Real)
    ccall((:cairo_mesh_pattern_set_corner_color_rgba, libcairo),
                    Nothing, (Ptr{Nothing},Int32,Float64,Float64,Float64,Float64),pat.ptr,corner_num,red,green,blue,alpha)
end

# ----

set_antialias(ctx::CairoContext, a) =
    ccall((:cairo_set_antialias,libcairo), Nothing,
          (Ptr{Nothing},Cint), ctx.ptr, a)

get_antialias(ctx::CairoContext) =
    ccall((:cairo_get_antialias,libcairo), Cint,
          (Ptr{Nothing},), ctx.ptr)

# -----------------------------------------------------------------------------

struct CairoMatrix
    xx::Float64
    yx::Float64
    xy::Float64
    yy::Float64
    x0::Float64
    y0::Float64
end

CairoMatrix() = CairoMatrix(0.0, 0.0, 0.0, 0.0, 0.0, 0.0)

function get_matrix(ctx::CairoContext)
    m = [CairoMatrix()]
    ccall((:cairo_get_matrix, libcairo), Nothing, (Ptr{Nothing}, Ptr{Nothing}), ctx.ptr, m)
    m[1]
end

function set_matrix(ctx::CairoContext, m::CairoMatrix)
    ccall((:cairo_set_matrix, libcairo), Nothing, (Ptr{Nothing}, Ptr{Nothing}), ctx.ptr, [m])
end

function set_matrix(p::CairoPattern, m::CairoMatrix)
    ccall((:cairo_pattern_set_matrix, libcairo), Nothing, (Ptr{Nothing}, Ptr{Nothing}), p.ptr, [m])
end

# -----------------------------------------------------------------------------
function get_font_matrix(ctx::CairoContext)
    m = [CairoMatrix()]
    ccall((:cairo_get_font_matrix, libcairo), Nothing, (Ptr{Nothing}, Ptr{Nothing}), ctx.ptr, m)
    m[1]
end

function set_font_matrix(ctx::CairoContext, m::CairoMatrix)
    ccall((:cairo_set_font_matrix, libcairo), Nothing, (Ptr{Nothing}, Ptr{Nothing}), ctx.ptr, [m])
end

# -----------------------------------------------------------------------------
function set_line_type(ctx::CairoContext, nick::AbstractString)
    if nick == "solid"
        dash = Float64[]
    elseif nick == "dotted" || nick == "dot"
        dash = [1.,3.]
    elseif nick == "dotdashed"
        dash = [1.,3.,4.,4.]
    elseif nick == "longdashed"
        dash = [6.,6.]
    elseif nick == "shortdashed" || nick == "dash" || nick == "dashed"
        dash = [4.,4.]
    elseif nick == "dotdotdashed"
        dash = [1.,3.,1.,3.,4.,4.]
    elseif nick == "dotdotdotdashed"
        dash = [1.,3.,1.,3.,1.,3.,4.,4.]
    else
        error("unknown line type ", nick)
    end
    set_dash(ctx, dash)
end

# -----------------------------------------------------------------------------
# text commands

function set_font_face(ctx::CairoContext, str::AbstractString)
    fontdesc = ccall((:pango_font_description_from_string,libpango),
                     Ptr{Nothing}, (Ptr{UInt8},), String(str))
    ccall((:pango_layout_set_font_description,libpango), Nothing,
          (Ptr{Nothing},Ptr{Nothing}), ctx.layout, fontdesc)
    ccall((:pango_font_description_free,libpango), Nothing,
          (Ptr{Nothing},), fontdesc)
end

function set_text(ctx::CairoContext, text::AbstractString, markup::Bool = false)
    if markup
        ccall((:pango_layout_set_markup,libpango), Nothing,
            (Ptr{Nothing},Ptr{UInt8},Int32), ctx.layout, String(text), -1)
    else
        # clear attributes (from previous set markups)
        ccall((:pango_layout_set_attributes,libpango), Nothing,
            (Ptr{Nothing},Ptr{Nothing}), ctx.layout, C_NULL)

        ccall((:pango_layout_set_text,libpango), Nothing,
            (Ptr{Nothing},Ptr{UInt8},Int32), ctx.layout, String(text), -1)
    end
    text
end

function get_layout_size(ctx::CairoContext)
    w = Vector{Int32}(undef, 2)
    ccall((:pango_layout_get_pixel_size,libpango), Nothing,
          (Ptr{Nothing},Ptr{Int32},Ptr{Int32}), ctx.layout, Ref(w,1), Ref(w,2))
    w
end

function update_layout(ctx::CairoContext)
    ccall((:pango_cairo_update_layout,libpangocairo), Nothing,
          (Ptr{Nothing},Ptr{Nothing}), ctx.ptr, ctx.layout)
end

function show_layout(ctx::CairoContext)
    ccall((:pango_cairo_show_layout,libpangocairo), Nothing,
          (Ptr{Nothing},Ptr{Nothing}), ctx.ptr, ctx.layout)
end

text_extents(ctx::CairoContext,value::AbstractString) =
    text_extents!(ctx,value, Matrix{Float64}(undef, 6, 1))

function text_extents!(ctx::CairoContext,value::AbstractString,extents)
    ccall((:cairo_text_extents, libcairo),
          Nothing, (Ptr{Nothing}, Ptr{UInt8}, Ptr{Float64}),
          ctx.ptr, String(value), extents)
    extents
end

function path_extents(ctx::CairoContext)
    dx1 = Cdouble[0]
    dx2 = Cdouble[0]
    dy1 = Cdouble[0]
    dy2 = Cdouble[0]

    ccall((:cairo_path_extents, libcairo),
          Nothing, (Ptr{Nothing}, Ptr{Cdouble}, Ptr{Cdouble},
          Ptr{Cdouble}, Ptr{Cdouble}),
          ctx.ptr, dx1, dy1, dx2, dy2)

    return(dx1[1],dy1[1],dx2[1],dy2[1])
end


function show_text(ctx::CairoContext,value::AbstractString)
    ccall((:cairo_show_text, libcairo),
          Nothing, (Ptr{Nothing}, Ptr{UInt8}),
          ctx.ptr, String(value))
end

function text_path(ctx::CairoContext,value::AbstractString)
    ccall((:cairo_text_path, libcairo),
          Nothing, (Ptr{Nothing}, Ptr{UInt8}),
          ctx.ptr, String(value))
end


function select_font_face(ctx::CairoContext,family::AbstractString,slant,weight)
    ccall((:cairo_select_font_face, libcairo),
          Nothing, (Ptr{Nothing}, Ptr{UInt8},
                 font_slant_t, font_weight_t),
          ctx.ptr, String(family),
          slant, weight)
end

function align2offset(a::AbstractString)
    if     a == "center" return 0.5
    elseif a == "left"   return 0.0
    elseif a == "right"  return 1.0
    elseif a == "top"    return 0.0
    elseif a == "bottom" return 1.0
    end
    @assert false
end

function text(ctx::CairoContext, x::Real, y::Real, str::AbstractString;
              halign::AbstractString = "left", valign::AbstractString = "bottom", angle::Real = 0, markup::Bool=false)
    move_to(ctx, x, y)
    save(ctx)
    reset_transform(ctx)
    rotate(ctx, -angle*pi/180.)

    set_text(ctx, str, markup)
    update_layout(ctx)

    extents = get_layout_size(ctx)
    dxrel = -align2offset(halign)
    dyrel = align2offset(valign)
    rel_move_to(ctx, dxrel*extents[1], -dyrel*extents[2])

    show_layout(ctx)
    restore(ctx)
    w, h = Graphics.device_to_user(ctx, extents[1], extents[2])
    BoundingBox(x+dxrel*w, x+(dxrel+1)*w, y-dyrel*h, y+(1-dyrel)*h)
end

function textwidth(ctx::CairoContext, str::AbstractString, markup::Bool = false)
    set_text(ctx, str, markup)
    extents = get_layout_size(ctx)
    extents[1]
end

function textheight(ctx::CairoContext, str::AbstractString, markup::Bool = false)
    set_text(ctx, str, markup)
    extents = get_layout_size(ctx)
    extents[2]
end

set_latex(ctx::CairoContext, str::AbstractString, fontsize::Real) = set_text(ctx, tex2pango(str, fontsize), true)

mutable struct TeXLexer
    str::String
    len::Int
    pos::Int
    token_stack::Array{String,1}

    function TeXLexer(str::AbstractString)
        s = String(str)
        new(s, lastindex(s), 1, String[])
    end
end

function get_token(self::TeXLexer)
    if self.pos > self.len
        return nothing
    end

    if length(self.token_stack) > 0
        return pop!(self.token_stack)
    end

    str = self.str[self.pos:end]
    re_control_sequence = r"^\\[a-zA-Z]+[ ]?|^\\[^a-zA-Z][ ]?"
    m = match(re_control_sequence, str)
    if m !== nothing
        token = m.match
        self.pos = self.pos + sizeof(token)
        # consume trailing space
        if length(token) > 2 && token[end] == ' '
            token = token[1:end-1]
        end
    else
        @static if VERSION >= v"0.7"
            token, self.pos = iterate(self.str, self.pos)
        else
            token, self.pos = next(self.str, self.pos)
        end
        token = string(token)
    end

    return token
end

function put_token(self::TeXLexer, token)
    push!(self.token_stack, token)
end

function peek(self::TeXLexer)
    token = get_token(self)
    put_token(self, token)
    return token
end

function map_text_token(token::AbstractString)
    if haskey(_text_token_dict, token)
        return _text_token_dict[token]
    else
        return get(_common_token_dict, token, token)
    end
end

function map_math_token(token::AbstractString)
    if haskey(_math_token_dict, token)
        return _math_token_dict[token]
    else
        return get(_common_token_dict, token, token)
    end
end

function math_group(lexer::TeXLexer)
    output = ""
    bracketmode = false
    while true
        token = get_token(lexer)
        if token == nothing
            break
        end

        if token == "{"
            bracketmode = true
        elseif token == "}"
            break
        else
            output = string(output, map_math_token(token))
            if !bracketmode
                break
            end
        end
    end
    return output
end

#font_code = [ "\\f0", "\\f1", "\\f2", "\\f3" ]

function tex2pango(str::AbstractString, fontsize::Real)
    output = ""
    mathmode = true
    font_stack = Any[]
    font = 1
    script_size = fontsize/1.618034

    lexer = TeXLexer(str)
    while true
        token = get_token(lexer)
        if token == nothing
            break
        end

        more_output = ""

        if token == "\$"
#            mathmode = !mathmode
            more_output = "\$"
        elseif token == "{"
            push!(font_stack, font)
        elseif token == "}"
            old_font = pop!(font_stack)
            if old_font != font
                font = old_font
#                more_output = font_code[font]
            end
        elseif token == "\\rm"
            font = 1
#            more_output = font_code[font]
        elseif token == "\\it"
            font = 2
#            more_output = font_code[font]
        elseif token == "\\bf"
            font = 3
#            more_output = font_code[font]
        elseif !mathmode
            more_output = map_text_token(token)
        elseif token == "_"
            more_output = string("<sub><span font=\"$script_size\">", math_group(lexer), "</span></sub>")
            #if peek(lexer) == "^"
            #    more_output = string("\\mk", more_output, "\\rt")
            #end
        elseif token == "^"
            more_output = string("<sup><span font=\"$script_size\">", math_group(lexer), "</span></sup>")
            #if peek(lexer) == "_"
            #    more_output = string("\\mk", more_output, "\\rt")
            #end
        else
            more_output = map_math_token(token)
        end

        output = string(output, more_output)
    end
    return output
end


@deprecate text(ctx::CairoContext,x::Real,y::Real,str::AbstractString,fontsize::Real,halign::AbstractString,valign,angle)    text(ctx,x,y,set_latex(ctx,str,fontsize),halign=halign,valign=valign,angle=angle,markup=true)
@deprecate layout_text(ctx::CairoContext, str::AbstractString, fontsize::Real)       set_latex(ctx, str, fontsize)
@deprecate textwidth(ctx::CairoContext, str::AbstractString, fontsize::Real)         textwidth(ctx, tex2pango(str, fontsize), true)
@deprecate textheight(ctx::CairoContext, str::AbstractString, fontsize::Real)        textheight(ctx, tex2pango(str, fontsize), true)
@deprecate cairo_write_to_ios_callback(s::Ptr{Nothing}, buf::Ptr{UInt8}, len::UInt32)   write_to_ios_callback(s, buf, len)
@deprecate cairo_write_to_stream_callback(s::IO, buf::Ptr{UInt8}, len::UInt32)       write_to_stream_callback(s, buf, len)
@deprecate text_extents(ctx::CairoContext,value::AbstractString,extents) text_extents!(ctx,value,extents)

if Base.VERSION >= v"1.4.2"
    ccall(:jl_generating_output, Cint, ()) == 1 || return nothing
    @assert precompile(Tuple{typeof(CairoImageSurface),Matrix{UInt32},Int32})   # time: 0.03191977
    @assert precompile(Tuple{typeof(copy),CairoContext})   # time: 0.02283907
    @assert precompile(Tuple{typeof(image),CairoContext,CairoSurfaceImage{UInt32},Int,Int,Float64,Float64})   # time: 0.002372729
    @assert precompile(Tuple{typeof(image),CairoContext,CairoSurfaceImage{UInt32},Float64,Float64,Float64,Float64})
    @assert precompile(Tuple{typeof(surface_create_similar),CairoSurfaceBase{UInt32}})   # time: 0.001453267
    @assert precompile(Tuple{typeof(user_to_device!),CairoContext,Vector{Float64}})   # time: 0.001948533
    @assert precompile(Tuple{typeof(device_to_user!),CairoContext,Vector{Float64}})   # time: 0.001546066
    @assert precompile(Tuple{typeof(destroy),CairoSurfaceImage{UInt32}})   # time: 0.001699678
    @assert precompile(Tuple{typeof(destroy),CairoContext})   # time: 0.001185085
    @assert precompile(Tuple{Type{CairoContext},CairoSurfaceBase{UInt32}})   # time: 0.001118005
end

end  # module

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, following here

arc(cr, 128.0, 128.0, 76.8, 0, 2 * pi);
clip(cr);

new_path(cr); # current path is not consumed by cairo_clip()
rectangle(cr, 0, 0, 256, 256);
fill(cr);
set_source_rgb(cr, 0, 1, 0);
move_to(cr, 0, 0);
line_to(cr, 256, 256);
move_to(cr, 256, 0);
line_to(cr, 0, 256);
set_line_width(cr, 10.0);
stroke(cr);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_clip.png");

using Cairo
using Colors
import Base.Sys

import Base.show

using Test

# Test that an the CairoSurface holds a reference to the passed IOBuffer
@testset "IOBuffer Rooting " begin
  CairoSVGSurface(IOBuffer(), 200, 110)
  GC.gc()
  GC.gc()
end

# Image Surface
@testset "Image Surface  " begin

    surf = CairoImageSurface(100, 200, Cairo.FORMAT_ARGB32)
    @test @inferred(width(surf)) == 100
    @test @inferred(height(surf)) == 200
    abstractsurf = Ref{CairoSurface}(surf)
    getwidth(r) = width(r[])
    getheight(r) = height(r[])
    @test @inferred(getwidth(abstractsurf)) == 100
    @test @inferred(getheight(abstractsurf)) == 200
    ctx = CairoContext(surf)
    @test @inferred(width(ctx)) == 100
    @test @inferred(height(ctx)) == 200

    surf = CairoImageSurface(fill(RGB24(0), 10, 10))
    @test Cairo.format(surf) == RGB24
    io = IOBuffer()
    show(io, MIME("image/png"), surf)

    seek(io,0)
    str_data = Vector{UInt8}(read(io))

    @test length(str_data) > 8 && str_data[1:8] == [0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a]
    surf = CairoImageSurface(fill(ARGB32(0), 10, 10))
    @test Cairo.format(surf) == ARGB32

end

@testset "Conversions    " begin

    include("shape_functions.jl")
    include("test_stream.jl")

    function test_pattern_get_surface()
        # test getting a surface from a surface pattern
        surf = CairoImageSurface(100, 200, Cairo.FORMAT_ARGB32)
        ctx = CairoContext(surf)
        Cairo.push_group(ctx)
        pattern = Cairo.pop_group(ctx)
        group_surf = Cairo.pattern_get_surface(pattern)
        @test group_surf.width == 100
        @test group_surf.height == 200

        # test that surfaces can't be gotten from non-surface patterns
        pattern = Cairo.pattern_create_linear(0, 0, 100, 200)
        @test_throws ErrorException Cairo.pattern_get_surface(pattern)
    end

    test_pattern_get_surface()

    # Test creating a CairoContext from a cairo_t pointer
    surf = CairoImageSurface(fill(ARGB32(0), 10, 10))
    ctx_ptr = ccall((:cairo_create, Cairo.libcairo),Ptr{Nothing}, (Ptr{Nothing}, ), surf.ptr)
    ctx = CairoContext(ctx_ptr)
    ccall((:cairo_destroy,Cairo.libcairo),Nothing, (Ptr{Nothing}, ), ctx_ptr)

    @test isa(ctx, CairoContext)
end

@testset "TexLexer       " begin
    include("tex.jl")
end

# Run all the samples -> success, if output file exits
@testset "Samples        " begin

    samples_dir_path = joinpath(dirname(dirname(@__FILE__)), "samples")
    samples_files = filter(str->endswith(str,".jl"), readdir(samples_dir_path))
    # filter known >= 1.12 -> sample_meshpattern.jl
    if Cairo.libcairo_version < v"1.12.0"
        files_to_exclude = ["sample_meshpattern.jl","sample_record0.jl","sample_record1.jl","sample_script0.jl"]
        samples_files = setdiff(samples_files, files_to_exclude)
    end

    @testset "sample: $test_file_name" for test_file_name in samples_files
        # Run each sample script in a separate module to avoid pollution
        s   = Symbol(test_file_name)
        mod = @eval(Main, module $s end)
        @eval mod include($(joinpath(samples_dir_path, test_file_name)))

        output_png_name = replace(test_file_name,".jl" => ".png")
        @test isfile(output_png_name)
        rm(output_png_name)
    end
end

# Run some painting, check the colored pixels by counting them
@testset "Bitmap Painting" begin

    include("test_painting.jl")

    # fill all
    z = zeros(UInt32,512,512);
    surf = CairoImageSurface(z, Cairo.FORMAT_ARGB32)
    # fills a 512x512 pixel area with blue,0.5 by using a hilbert curve of
    # dimension 64 (scaled by 8 -> 512) and a linewidth of 8
    hdraw(surf,64,8,8)

    d = simple_hist(surf.data)

    @test length(d) == 1
    @test collect(keys(d))[1] == 0x80000080

    # fill 1/4 (upper quarter)
    z = zeros(UInt32,512,512);
    surf = CairoImageSurface(z, Cairo.FORMAT_ARGB32)
    # fills a 256x256 pixel area with blue,0.5 by using a hilbert curve of
    # dimension 32 (scaled by 8 -> 256) and a linewidth of 8
    hdraw(surf,32,8,8)

    d = simple_hist(surf.data)

    @test length(d) == 2
    @test d[0x80000080] == 256*256

    # fill ~1/2 full,
    z = zeros(UInt32,512,512);
    surf = CairoImageSurface(z, Cairo.FORMAT_ARGB32)
    # fills a 512x512 pixel area with blue,0.5 by using a hilbert curve of
    # dimension 64 (scaled by 8 -> 512) and a linewidth of 4 -> 1/4 of pixels -16
    hdraw(surf,64,8,4)

    d = simple_hist(surf.data)

    @test length(d) == 2
    @test d[0x80000080] == ((512*256)-16)
end

# vector surfaces
@testset "Vector Surfaces" begin

    output_file_name = "a.svg"
    surf = CairoSVGSurface(output_file_name,512,512)
    hdraw(surf,64,8,4)
    finish(surf)

    @test isfile(output_file_name)
    rm(output_file_name)

    io = IOBuffer()
    surf = CairoSVGSurface(io,512,512)
    hdraw(surf,64,8,4)
    finish(surf)

    seek(io,0)
    str_data = Vector{UInt8}(read(io))

    @test length(str_data) > 31000 && str_data[1:13] == [0x3c,0x3f,0x78,0x6d,0x6c,0x20,0x76,0x65,0x72,0x73,0x69,0x6f,0x6e]

    output_file_name = "a.pdf"
    surf = CairoPDFSurface(output_file_name,512,512)
    hdraw(surf,64,8,4)
    finish(surf)

    @test isfile(output_file_name)
    rm(output_file_name)

    io = IOBuffer()
    surf = CairoPDFSurface(io,512,512)
    hdraw(surf,64,8,4)
    finish(surf)

    seek(io,0)
    str_data = Vector{UInt8}(read(io))

    @test length(str_data) > 3000 && str_data[1:7] == [0x25,0x50,0x44,0x46,0x2d,0x31,0x2e]

    output_file_name = "a.eps"
    surf = CairoEPSSurface(output_file_name,512,512)
    hdraw(surf,64,8,4)
    finish(surf)

    @test isfile(output_file_name)
    rm(output_file_name)

    io = IOBuffer()
    surf = CairoEPSSurface(io,512,512)
    hdraw(surf,64,8,4)
    finish(surf)

    seek(io,0)
    str_data = Vector{UInt8}(read(io))

    @test length(str_data) > 3000 && str_data[1:10] == [0x25,0x21,0x50,0x53,0x2d,0x41,0x64,0x6f,0x62,0x65]

    output_file_name = "a.ps"
    surf = CairoPSSurface(output_file_name,512,512)
    hdraw(surf,64,8,4)
    finish(surf)

    @test isfile(output_file_name)
    rm(output_file_name)

    io = IOBuffer()
    surf = CairoPSSurface(io,512,512)
    hdraw(surf,64,8,4)
    finish(surf)

    seek(io,0)
    str_data = Vector{UInt8}(read(io))

    @test length(str_data) > 3000 && str_data[1:10] == [0x25,0x21,0x50,0x53,0x2d,0x41,0x64,0x6f,0x62,0x65]

    if Cairo.libcairo_version >= v"1.12.0"

        # just write to surface and test for content
        io = IOBuffer()
        surf = CairoScriptSurface(io,512,512)
        hdraw(surf,64,8,4)
        finish(surf)

        seek(io,0)
        str_data = Vector{UInt8}(read(io))

        @test length(str_data) > 3000 && str_data[1:10] == [0x25,0x21,0x43,0x61,0x69,0x72,0x6f,0x53,0x63,0x72]

        # create_for_target
        z = zeros(UInt32,512,512);
        surf = CairoImageSurface(z, Cairo.FORMAT_ARGB32)

        io = IOBuffer()
        scsurf = CairoScriptSurface(io,surf)
        hdraw(scsurf,64,8,8)
        finish(surf)
        destroy(scsurf)

        seek(io,0)
        str_data = Vector{UInt8}(read(io))

        @test length(str_data) > 3000 && str_data[1:10] == [0x25,0x21,0x43,0x61,0x69,0x72,0x6f,0x53,0x63,0x72]

        d = simple_hist(surf.data)

        @test length(d) == 1
        @test collect(keys(d))[1] == 0x80000080


    end
end

# pixel/bitmap surfaces
@testset "Bitmap Surfaces" begin

    z = zeros(UInt32,512,512)
    surf = CairoImageSurface(z, Cairo.FORMAT_ARGB32)

    hilbert_colored(surf)
    d1 = matrix_read(surf)
    d = simple_hist(d1)

    @test length(d) == 513 # 512 colors and empty background

    surf = CairoARGBSurface(z)

    hilbert_colored(surf)
    d1 = matrix_read(surf)
    d = simple_hist(d1)

    @test length(d) == 513

    surf = CairoRGBSurface(z)

    hilbert_colored(surf)
    d1 = matrix_read(surf)
    d = simple_hist(d1)

    @test length(d) == 512 # black is included

    # width: 5, height: 3; Test-Image
    mat = [ 0x80800000  0x00000000  0x00000000
            0x80800000  0x00000000  0x00000000
            0x80800000  0x33000033  0x33000033
            0x80800000  0x33000033  0x33000033
            0xff00ff00  0xff00ff00  0x00000000 ]
    surf = CairoImageSurface(mat, Cairo.FORMAT_ARGB32; flipxy=false)
    data_arr = unsafe_wrap(Array, Cairo.image_surface_get_data(surf), (5, 3))
    @test (mat == data_arr) && (mat == surf.data)
end

@testset "Assert/Status  " begin

    z = zeros(UInt32,512,512);
    surf = CairoImageSurface(z, Cairo.FORMAT_ARGB32)

    @test Cairo.status(surf) == 0

    pa = surf.ptr
    surf.ptr = C_NULL

    @test destroy(surf) == nothing

    surf.ptr = pa
    cr = Cairo.CairoContext(surf)

    pa = cr.ptr
    cr.ptr = C_NULL

    @test destroy(cr) == nothing

    @test push_group(cr) == nothing
    @test pop_group(cr) == nothing

    @test_throws AssertionError Cairo.align2offset("to")

    @test_throws ErrorException Cairo.set_line_type(cr,"nondef")
end

@testset "reset_transform" begin
    using Graphics

    z = zeros(UInt32,512,512);
    surf = CairoImageSurface(z, Cairo.FORMAT_ARGB32)

    @test Cairo.status(surf) == 0

    pa = surf.ptr
    surf.ptr = C_NULL

    @test destroy(surf) == nothing

    surf.ptr = pa
    cr = Cairo.CairoContext(surf)

    m1 = CairoMatrix(1, 0, 0, 1, 0, 0)
    m2 = CairoMatrix(1.0,2.0,2.0,1.0,0.,0.)
    m = get_matrix(cr)
    @test m == m1
    set_matrix(cr, m2)
    @test get_matrix(cr) == m2
    Graphics.reset_transform(cr)
    @test get_matrix(cr) == m1
    @test destroy(cr) == nothing
end

@testset "font_matrix" begin
    z = zeros(UInt32,512,512);
    surf = CairoImageSurface(z, Cairo.FORMAT_ARGB32)

    pa = surf.ptr
    surf.ptr = C_NULL

    surf.ptr = pa
    cr = Cairo.CairoContext(surf)

    m = CairoMatrix(1.0,2.0,2.0,1.0,0.,0.)
    set_font_matrix(cr, m)
    @test m == get_font_matrix(cr)
    @test destroy(cr) == nothing
end

nothing

## header to provide surface and context
using Cairo

c = CairoRGBSurface(256,256)
cr = CairoContext(c)

save(cr)
set_source_rgb(cr,0.8,0.8,0.8)    # light gray
rectangle(cr,0.0,0.0,256.0,256.0) # background
fill(cr)
restore(cr)

save(cr)

## original example, following here
move_to(cr, 16.0, 32.0)
curve_to(cr, 16.0, 16.0, 16.0, 16.0, 32.0, 16.0)

opath = Cairo.convert_cairo_path_data(Cairo.copy_path(cr))
dx,dy,ex,ey = path_extents(cr)

fpath = Cairo.convert_cairo_path_data(Cairo.copy_path_flat(cr))

stroke(cr)

restore(cr)

l = 2 # something like a line counter

# loop over all entries and just print out command and available points
for x in opath
    if x.element_type == Cairo.CAIRO_PATH_MOVE_TO
        s0 = "moveto"
    elseif x.element_type == Cairo.CAIRO_PATH_LINE_TO
        s0 = "lineto"
    elseif x.element_type == Cairo.CAIRO_PATH_CURVE_TO
        s0 = "curveto"
    elseif x.element_type == Cairo.CAIRO_PATH_CLOSE_PATH
        s0 = "closepath"
    end
    s1 = repr(x.points)
    move_to(cr,10.0,16.0+(14.0*l))
    global l += 1
    show_text(cr,s0*s1)
end

l = 2 # something like a line counter

# loop over all entries and just print out command and available points
for x in fpath
    if x.element_type == Cairo.CAIRO_PATH_MOVE_TO
        s0 = "moveto"
    elseif x.element_type == Cairo.CAIRO_PATH_LINE_TO
        s0 = "lineto"
    elseif x.element_type == Cairo.CAIRO_PATH_CURVE_TO
        s0 = "curveto"
    elseif x.element_type == Cairo.CAIRO_PATH_CLOSE_PATH
        s0 = "closepath"
    end
    s1 = repr(x.points)
    move_to(cr,10.0,50.0+(14.0*l))
    global l += 1
    show_text(cr,s0*s1)
end


## mark picture with current date
restore(cr)

move_to(cr,0.0,12.0)
set_source_rgb(cr, 0,0,0)
show_text(cr,Libc.strftime(time()))

write_to_png(c,"sample_copy_path_flat.png")

# some collection of some painting plus support functions

"""
function ngray(base::Int,digits::Int,value::Int)
Convert a value to a graycode with the given base and digits
"""
function ngray(base::Int,digits::Int,value::Int)
    baseN = zeros(Int,digits)
    gray = zeros(Int,1,digits)

	for i=1:digits
		baseN[i] = value % base
		value = div(value,base)
	end

	shift = 0
	for i=digits:-1:1
		gray[i] = (baseN[i] + shift) % base
		shift = shift + base - gray[i]
	end
	gray
end

"""
function hilbert_curve(c,x,y,lg,i1,i2)
recursive hilbert curve (2D), appends pairs of x,y to c, lg = dimension/length
"""
function hilbert_curve(c,x,y,lg,i1,i2)
    if lg == 1
        append!(c,[x,y])
    else
        lg = lg / 2;
        hilbert_curve(c,x+i1*lg,y+i1*lg,lg,i1,1-i2);
        hilbert_curve(c,x+i2*lg,y+(1-i2)*lg,lg,i1,i2);
        hilbert_curve(c,x+(1-i1)*lg,y+(1-i1)*lg,lg,i1,i2);
        hilbert_curve(c,x+(1-i2)*lg,y+i2*lg,lg,1-i1,i2);
    end
end


function hilbert_colored(surf)

    zscale = 8;
    n1 = 8;
    cr = CairoContext(surf)

    c = Float64[]
    hilbert_curve(c,0,0,64,0,0)

    move_to(cr,0,0)

    translate(cr,zscale/2,zscale/2)
    scale(cr,zscale,zscale)
    set_line_width(cr,zscale/2)
    set_line_cap(cr,Cairo.CAIRO_LINE_CAP_SQUARE)

    for k in zip(collect(1:2:(length(c)-2)),1:(length(1:2:(length(c)-2))))
        move_to(cr,c[k[1]],c[k[1]+1])
        line_to(cr,c[k[1]+2],c[k[1]+3])

        c1 = ngray(n1,3,k[2])
        set_source_rgb(cr,c1[1]/float(n1-1),c1[2]/float(n1-1),c1[3]/float(n1-1))
        stroke(cr)

    end
end


""" function hdraw(s,dim,zscale,linewidth)
draws a hilbert curve with dimension dim (power of 2) and scales the drawing with
zscale.
"""
function hdraw(s,dim,zscale,linewidth)

    cr = CairoContext(s)

    set_source_rgba(cr,0.0,0.0,1.0,0.5)

    set_line_width(cr,linewidth)
    set_line_cap(cr,Cairo.CAIRO_LINE_CAP_SQUARE)
    translate(cr,zscale/2,zscale/2)

    save(cr)
    c = Float64[]

    hilbert_curve(c,0,0,dim,0,0)

    scale(cr,zscale,zscale)

    move_to(cr,0,0)
    for k=1:div(length(c),2)
        line_to(cr,c[(k*2)-1],c[(k*2)])
    end

    stroke(cr)
    restore(cr)
end

"""
function simple_hist(data)
    simple histogram by population count in a Dict
"""
function simple_hist(data)
    # poor man's hist -> pop count in Dict

    pc = Dict()

    for d in data
        if d in keys(pc)
            pc[d] += 1
        else
            pc[d] = 1
        end
    end
    pc
end

"""
function matrix_read(surface)
	paint the input surface into a matrix image of the same size to access
	the pixels.
"""
function matrix_read(surface)
	w = Int(surface.width)
	h = Int(surface.height)
	z = zeros(UInt32,w,h)
	surf = CairoImageSurface(z, Cairo.FORMAT_ARGB32)

    cr = CairoContext(surf)
    set_source_surface(cr,surface,0,0)
    paint(cr)

    surf.data
end

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, following here
set_line_width(cr, 6);

rectangle(cr, 12, 12, 232, 70);
new_sub_path(cr); arc(cr, 64, 64, 40, 0, 2*pi);
new_sub_path(cr); arc_negative(cr, 192, 64, 40, 0, -2*pi);

set_fill_type(cr, Cairo.CAIRO_FILL_RULE_EVEN_ODD); # should be set_fill_rule
set_source_rgb(cr, 0, 0.7, 0); fill_preserve(cr);
set_source_rgb(cr, 0, 0, 0); stroke(cr);

translate(cr, 0, 128);
rectangle(cr, 12, 12, 232, 70);
new_sub_path(cr); arc(cr, 64, 64, 40, 0, 2*pi);
new_sub_path(cr); arc_negative(cr, 192, 64, 40, 0, -2*pi);

set_fill_type(cr, Cairo.CAIRO_FILL_RULE_WINDING);
set_source_rgb(cr, 0, 0, 0.9); fill_preserve(cr);
set_source_rgb(cr, 0, 0, 0); stroke(cr);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_fill_style.png");

using Cairo

function common_header()
    ## header to provide surface and context
    c = CairoRGBSurface(256,256);
    cr = CairoContext(c);

    save(cr);
    set_source_rgb(cr,0.8,0.8,0.8);    # light gray
    rectangle(cr,0.0,0.0,256.0,256.0); # background
    fill(cr);
    restore(cr);

    return c,cr
end

function write_out_picture(filename::AbstractString,c::CairoSurface)
    ## mark picture with current date
    move_to(cr,0.0,12.0);
    set_source_rgb(cr, 0,0,0);
    show_text(cr,Libc.strftime(time()));
    ##
    write_to_png(c,filename);
    nothing
end

function example_copy_path(cr)

    save(cr);
    # single (large) character set with text_path+stroke
    select_font_face(cr, "Sans", Cairo.FONT_SLANT_NORMAL,
                        Cairo.FONT_WEIGHT_BOLD);
    set_font_size(cr, 100.0);
    translate(cr, 10.0, 100.0);
    text_path(cr, "J");
    stroke_preserve(cr);

    # copied and converted
    opath = Cairo.convert_cairo_path_data(Cairo.copy_path(cr));

    restore(cr);

    l = 2 # something like a line counter

    # loop over all entries and just print out command and available points
    for x in opath
        if x.element_type == Cairo.CAIRO_PATH_MOVE_TO
            s0 = "moveto"
        elseif x.element_type == Cairo.CAIRO_PATH_LINE_TO
            s0 = "lineto"
        elseif x.element_type == Cairo.CAIRO_PATH_CURVE_TO
            s0 = "curveto"
        elseif x.element_type == Cairo.CAIRO_PATH_CLOSE_PATH
            s0 = "closepath"
        end
        s1 = repr(x.points)
        move_to(cr,100.0,14.0*l)
        l += 1
        show_text(cr,s0*s1)
    end
    nothing
end


c,cr = common_header();
save(cr);
example_copy_path(cr);
restore(cr);
write_out_picture("sample_copy_path.png",c);

using Cairo
include("shape_functions.jl")

function test_all(;tmax = 2.0, save_flag = false)
    print("cairo version: ",Cairo.libcairo_version,"\n");
    size_surface = [512];#,512,1024]; #three sizes of a surface
    paint_width = [0.5,1.0,3.0,5.0];
    shapes = [ddots1, ddots2, ddots3, ddots4, ddots5,
              rdots1, rdots2, rdots3, rdots4, rdots5, rdots6,
              lines0, lines1, lines2, lines3, lines4];
    n_elements = [100,300,1000,3000,10000,30000,100000];

    n_tests = length(size_surface) * length(paint_width) * length(shapes);
    test_data = zeros(n_tests+1,3 + length(n_elements));
    test_data[1,3+(1:length(n_elements))] = n_elements;
    i = 1;

    if save_flag && !isdir("test_results")
        mkdir("test_results")
    end

    for s_size in size_surface
        s = Cairo.CairoARGBSurface(s_size,s_size);
        c = Cairo.CairoContext(s);
        print("Surface Size: ",s_size,"\n")
        for w in paint_width
            print("Paint Width: ",w,"\n")
            for m_index in 1:length(shapes)
                test_data[i,1] = s_size;
                test_data[i,2] = w;
                test_data[i,3] = m_index;
                m = shapes[m_index];
                for n_index in 1:length(n_elements)
                    n = n_elements[n_index];
                    t = @elapsed(m(c,s_size,s_size,w,n));
                    print(m," ",@sprintf("%6d",n),"  elapsed time: ",@sprintf("%f seconds",t),"\n");
                    test_data[i+1,3+n_index] = t;
                    if save_flag
                        write_to_png(s,@sprintf("test_results/test_speed_%2.1f_%02d_%02d.png",w,m_index,n_index));
                    end
                    if t > tmax && n_index < length(n_elements)
                        println("Remaining tests in this sequence skipped")
                        break
                    end
                end
                print("\n")
                i += 1;
            end
        end
    end
end

test_all()

## header to provide surface and context
using Cairo
using Printf

c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);

set_font_face(cr, "Sans 16")

text(cr,16.0,40.0,"Hamburgefons")
text(cr,16.0,72.0,"sp⁰¹²³,min⁻²,αΑβΒφϕΦγΓ")
text(cr,16.0,104.0,"Text<b>Bold</b><i>Italic</i><sup>super-2</sup>",markup=true)

text(cr,40.0,224.0,"Es geht <span foreground=\"white\" background=\"blue\">aufwärts</span> !",markup=true,angle=30.0)

#using textwidth and height

set_font_face(cr, "Sans 12")

a = "A"
aheight = textheight(cr,a)
awidth = textwidth(cr,a)
atext = @sprintf("%s wd=%2.2f,ht=%2.2f",a,awidth,aheight)
text(cr,16.0,240.0,atext,markup=true)


## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_pango_text.png");

## header to provide surface and context
using Cairo
using Graphics

c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);

# put image top left
s = read_from_png("data/mulberry.png"); 
Cairo.image(cr,s,0,0,128,128)

# copy inplace, so to apply copy as source, need coordinate translate
c1 = copy(cr)

save(cr)
translate(cr,128,0)
rectangle(cr,0,0,256,256)
set_source_surface(cr,c1.surface)
paint(cr)
restore(cr)

# copy centered part 
c2 = copy(cr,Graphics.BoundingBox(64,192,0,128))

save(cr)

rectangle(cr,0,0,256,256)
set_source_surface(cr,c2.surface,64,128)
paint(cr)
restore(cr)

## mark picture with current date
restore(cr); 
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_image_copy.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, following here

image = read_from_png("data/mulberry.png");
w = image.width; 
h = image.height;

translate(cr, 128.0, 128.0);
rotate(cr, 45* pi/180);
scale(cr, 256.0/w, 256.0/h);
translate(cr, -0.5*w, -0.5*h);

set_source_surface(cr, image, 0, 0);
paint(cr);
#surface_destroy (image);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_image.png");

using Cairo
using Random

# shape functions,


function randpos(n,w::Real,h::Real)
    @static if VERSION >= v"0.7"
        Random.seed!(141413)
    else
        srand(141413)
    end
    px = rand(n)*w
    py = rand(n)*h
    return (px,py)
end

function clear_bg(c::CairoContext,w::Real,h::Real)
    save(c)
    set_source_rgb(c,1.0,1.0,1.0)
    rectangle(c, 0,0,w,h)
    paint(c)
    restore(c)
end

# ddotsx: fill random dots with different methods, disc only (no ring)
function ddots1(cr::CairoContext, rect_width::Real, rect_height::Real, radius::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    new_path(cr)
    for i=1:n
       move_to(cr,px[i],py[i])
       rel_move_to(cr,radius,0)
       arc(cr, px[i], py[i], radius, 0, 2*pi)
    end
    close_path(cr)

    set_source_rgb(cr, 0, 0, 1.0)
    fill(cr)
end

function ddots2(cr::CairoContext, rect_width::Real, rect_height::Real, radius::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    for i=1:n
        new_path(cr)
        move_to(cr,px[i],py[i])
        rel_move_to(cr,radius,0)
        arc(cr, px[i], py[i], radius, 0, 2*pi)
        close_path(cr)
        set_source_rgb(cr, 0, 0, 1.0)
        fill(cr)
    end
end


function ddots3(cr::CairoContext, rect_width::Real, rect_height::Real, radius::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    new_path(cr)

    set_source_rgb(cr, 0, 0, 1.0)
    set_line_cap(cr,Cairo.CAIRO_LINE_CAP_ROUND)
    set_line_width(cr,radius*2.0)

    for i=1:n
       move_to(cr,px[i],py[i])
       rel_line_to(cr,0,0)
       stroke(cr)
    end

    close_path(cr)

end

function ddots4(cr::CairoContext,
    rect_width::Real, rect_height::Real, radius::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    cc = radius + 1

    rectangle(cr,0,0,2*cc,2*cc)
    clip(cr)
    push_group(cr)
    arc(cr,radius,radius,radius,0,2*pi)
    set_source_rgb(cr,0,0,1.0)
    fill(cr)
    p = pop_group(cr)
    reset_clip(cr)

    for i=1:n
        save(cr)
        translate(cr,px[i]-cc,py[i]-cc)
        set_source(cr,p)
        paint(cr)
        restore(cr)
    end
end

function ddots5(cr::CairoContext,
    rect_width::Real, rect_height::Real, radius::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    cc = radius + 1

    s1 = Cairo.CairoARGBSurface(cc*2,cc*2)
    c1 = Cairo.CairoContext(s1)
    rectangle(c1,0,0,2*cc,2*cc)
    set_source_rgba(c1,0,0,0,0)
    paint(c1)
    new_path(c1)
    arc(c1,radius,radius,radius,0,2*pi)
    set_source_rgb(c1,0,0,1.0)
    fill(c1)

    p = Cairo.CairoPattern(s1)

    for i=1:n
        save(cr)
        translate(cr,px[i]-cc,py[i]-cc)
        set_source(cr,p)
        paint(cr)
        restore(cr)
    end
end

# rdotsx: fill random dots with different methods
function rdots1(cr::CairoContext, rect_width::Real, rect_height::Real, radius::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    new_path(cr)
    for i=1:n
       move_to(cr,px[i],py[i])
       rel_move_to(cr,radius,0)
       arc(cr, px[i], py[i], radius, 0, 2*pi)
    end
    close_path(cr)

    set_source_rgb(cr, 0, 0, 1.0)
    fill_preserve(cr)
    set_line_width(cr,1.0)
    set_source_rgb(cr, 0, 0, 0)
    stroke(cr)
end

function rdots2(cr::CairoContext, rect_width::Real, rect_height::Real, radius::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    for i=1:n
        new_path(cr)
        move_to(cr,px[i],py[i])
        rel_move_to(cr,radius,0)
        arc(cr, px[i], py[i], radius, 0, 2*pi)
        close_path(cr)
        set_source_rgb(cr, 0, 0, 1.0)
        fill_preserve(cr)
        set_line_width(cr,1.0)
        set_source_rgb(cr, 0, 0, 0)
        stroke(cr)
    end
end


function rdots3(cr::CairoContext, rect_width::Real, rect_height::Real, radius::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    new_path(cr)

    set_line_cap(cr,Cairo.CAIRO_LINE_CAP_ROUND)

    set_source_rgb(cr, 0, 0, 0)
    set_line_width(cr,radius*2 + 2.0)
    for i=1:n
       move_to(cr,px[i],py[i])
       rel_line_to(cr,0,0)
       stroke(cr)
    end

    set_source_rgb(cr, 0, 0, 1.0)
    set_line_width(cr,radius*2)
    for i=1:n
       move_to(cr,px[i],py[i])
       rel_line_to(cr,0,0)
       stroke(cr)
    end


end

function rdots4(cr::CairoContext,
    rect_width::Real, rect_height::Real, radius::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    cc = radius + 3.0

    rectangle(cr,0,0,2*cc,2*cc)
    clip(cr)
    push_group(cr)
    arc(cr,radius,radius,radius,0,2*pi)
    set_source_rgb(cr,0,0,1.0)
    fill_preserve(cr)
    set_source_rgb(cr,0,0,0)
    set_line_width(cr,1.0)
    stroke(cr)
    p = pop_group(cr)
    reset_clip(cr)

    for i=1:n
        save(cr)
        translate(cr,px[i]-cc,py[i]-cc)
        set_source(cr,p)
        paint(cr)
        restore(cr)
    end
end

function rdots5(cr::CairoContext,
    rect_width::Real, rect_height::Real, radius::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    cc = radius + 3.0

    s1 = Cairo.CairoARGBSurface(cc*2,cc*2)
    c1 = Cairo.CairoContext(s1)
    rectangle(c1,0,0,2*cc,2*cc)
    set_source_rgba(c1,0,0,0,0)
    paint(c1)
    new_path(c1)
    arc(c1,radius+1,radius+1,radius,0,2*pi)
    set_source_rgb(c1,0,0,1.0)
    fill_preserve(c1)
    set_source_rgb(c1,0,0,0)
    set_line_width(c1,1.0)
    stroke(c1)

    p = Cairo.CairoPattern(s1)

    for i=1:n
        save(cr)
        translate(cr,px[i]-cc,py[i]-cc)
        set_source(cr,p)
        paint(cr)
        restore(cr)
    end
end

# alpha transparency using paint_with_alpha
function rdots6(cr::CairoContext,
    rect_width::Real, rect_height::Real, radius::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    cc = radius + 3.0

    s1 = Cairo.CairoARGBSurface(cc*2,cc*2)
    c1 = Cairo.CairoContext(s1)
    rectangle(c1,0,0,2*cc,2*cc)
    set_source_rgba(c1,0,0,0,0)
    paint_with_alpha(c1, 0.5)
    new_path(c1)
    arc(c1,radius+1,radius+1,radius,0,2*pi)
    set_source_rgb(c1,0,0,1.0)
    fill_preserve(c1)
    set_source_rgb(c1,0,0,0)
    set_line_width(c1,1.0)
    stroke(c1)

    p = Cairo.CairoPattern(s1)

    for i=1:n
        save(cr)
        translate(cr,px[i]-cc,py[i]-cc)
        set_source(cr,p)
        paint_with_alpha(cr, 1 - i/n)
        restore(cr)
    end
end

# lines0, random x,y lines
function lines0(cr::CairoContext, rect_width::Real, rect_height::Real, width::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    new_path(cr)

    set_source_rgb(cr, 0, 0, 1.0)
    set_line_width(cr,width)

    new_path(cr)
    move_to(cr,px[1],py[1])
    for i=2:n
       line_to(cr,px[i],py[i])
    end
    stroke(cr)
end

# lines1, x sorted, line a plot
function lines1(cr::CairoContext, rect_width::Real, rect_height::Real, width::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    px = sort(px)

    set_source_rgb(cr, 0, 0, 1.0)
    set_line_width(cr,width)

    new_path(cr)
    move_to(cr,px[1],py[1])
    for i=2:n
        line_to(cr,px[i],py[i])
    end
    stroke(cr)
end

# lines2, x sorted, independent lines per coord
function lines2(cr::CairoContext, rect_width::Real, rect_height::Real, width::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    px = sort(px)

    set_source_rgb(cr, 0, 0, 1.0)
    set_line_width(cr,width)

    new_path(cr)
    for i=1:n-1
        move_to(cr,px[i],py[i])
        line_to(cr,px[i+1],py[i+1])
        stroke(cr)
    end
end

# lines3, x sorted, in clusters of 100
function lines3(cr::CairoContext, rect_width::Real, rect_height::Real, width::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    px = sort(px)

    set_source_rgb(cr, 0, 0, 1.0)
    set_line_width(cr,width)
    new_path(cr)
    for c = 1:100:n
        move_to(cr,px[c],py[c])
        for i=c:min(c+100,n)
            line_to(cr,px[i],py[i])
        end
        stroke(cr)
    end
end

# lines4, x sorted, in clusters of 1000
function lines4(cr::CairoContext, rect_width::Real, rect_height::Real, width::Real, n::Int)

    clear_bg(cr,rect_width,rect_height)
    px,py = randpos(n,rect_width,rect_height)

    px = sort(px)

    set_source_rgb(cr, 0, 0, 1.0)
    set_line_width(cr,width)
    new_path(cr)
    for c = 1:1000:n
        move_to(cr,px[c],py[c])
        for i=c:min(c+1000,n)
            line_to(cr,px[i],py[i])
        end
        stroke(cr)
    end
end

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);

## original example, following here

pat = pattern_create_linear(0.0, 0.0,  0.0, 256.0);
pattern_add_color_stop_rgb(pat, 1, 0, 0, 0); # alpha=1
pattern_add_color_stop_rgb(pat, 0, 1, 1, 1);
rectangle(cr, 0, 0, 256, 256);
set_source(cr, pat);
fill(cr);
destroy(pat);

pat = pattern_create_radial(115.2, 102.4, 25.6,
                            102.4,  102.4, 128.0);
pattern_add_color_stop_rgba(pat, 0, 1, 1, 1, 1); # explicit alpha=1
pattern_add_color_stop_rgba(pat, 1, 0, 0, 0, 1);
set_source(cr, pat);
arc(cr, 128.0, 128.0, 76.8, 0, 2 * pi);
fill(cr);
destroy(pat);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_gradient.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);

## original example, following here

# custom shape wrapped in a function
function shape_curve_rectangle(cr::CairoContext,x0::Real,y0::Real,
    rect_width::Real, rect_height::Real, radius::Real)
    
    save(cr);
    
    x1=x0+rect_width;
    y1=y0+rect_height;
    
    if (rect_width == 0 || rect_height == 0)
        return;
        end
    if (rect_width/2 < radius) 
        if (rect_height/2 < radius) 
            move_to(cr, x0, (y0 + y1)/2);
            curve_to(cr, x0 ,y0, x0, y0, (x0 + x1)/2, y0);
            curve_to(cr, x1, y0, x1, y0, x1, (y0 + y1)/2);
            curve_to(cr, x1, y1, x1, y1, (x1 + x0)/2, y1);
            curve_to(cr, x0, y1, x0, y1, x0, (y0 + y1)/2);
        else 
            move_to(cr, x0, y0 + radius);
            curve_to(cr, x0 ,y0, x0, y0, (x0 + x1)/2, y0);
            curve_to(cr, x1, y0, x1, y0, x1, y0 + radius);
            line_to(cr, x1 , y1 - radius);
            curve_to(cr, x1, y1, x1, y1, (x1 + x0)/2, y1);
            curve_to(cr, x0, y1, x0, y1, x0, y1- radius);
        end
    
    else
        if (rect_height/2 < radius) 
            move_to(cr, x0, (y0 + y1)/2);
            curve_to(cr, x0 , y0, x0 , y0, x0 + radius, y0);
            line_to(cr, x1 - radius, y0);
            curve_to(cr, x1, y0, x1, y0, x1, (y0 + y1)/2);
            curve_to(cr, x1, y1, x1, y1, x1 - radius, y1);
            line_to(cr, x0 + radius, y1);
            curve_to(cr, x0, y1, x0, y1, x0, (y0 + y1)/2);
        else 
            move_to(cr, x0, y0 + radius);
            curve_to(cr, x0 , y0, x0 , y0, x0 + radius, y0);
            line_to(cr, x1 - radius, y0);
            curve_to(cr, x1, y0, x1, y0, x1, y0 + radius);
            line_to(cr, x1 , y1 - radius);
            curve_to(cr, x1, y1, x1, y1, x1 - radius, y1);
            line_to(cr, x0 + radius, y1);
            curve_to(cr, x0, y1, x0, y1, x0, y1- radius);
        end
    end
    close_path(cr);

    set_source_rgb(cr, 0.5, 0.5, 1);
    fill_preserve(cr);
    set_source_rgba(cr, 0.5, 0, 0, 0.5);
    set_line_width(cr, 10.0);
    stroke(cr);
    restore(cr);
    return;
    end

shape_curve_rectangle(cr,25.6,25.6,204.8,204.8,102.4);    

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_curve_rectangle.png");

# So that this test can be run independently
using Cairo
using Base64

include("shape_functions.jl")

@testset "Test that writing images to a Julia IO object works" begin
    c = CairoRGBSurface(256,256)
    cr = CairoContext(c)
    ddots4(cr,256,246,1.0,3000)
    buf = IOBuffer()
    pipe = Base64EncodePipe(buf)
    write_to_png(c,pipe)
    close(pipe)

    # Catch short writes

    str = String(take!(buf))
    str_data = codeunits(str)

    @test length(str_data) > 200
end

@testset "Test that writing images to a temp file works" begin
    c = CairoRGBSurface(256,256)
    cr = CairoContext(c)
    ddots4(cr,256,246,1.0,3000)
    fn = tempname()*".png"
    @test write_to_png(c,fn) == Cairo.STATUS_SUCCESS
    @test isfile(fn)
    rm(fn)  # clean up
end

## header to provide surface and context
using Cairo

c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

## original example, following here
xc = 128.0;
yc = 128.0;
radius = 100.0;
angle1 = 45.0  * (pi/180.0);  # angles are specified
angle2 = 180.0 * (pi/180.0);  # in radians

set_line_width(cr, 10.0);
arc(cr, xc, yc, radius, angle1, angle2);
stroke(cr);

# draw helping lines
set_source_rgba(cr, 1, 0.2, 0.2, 0.6);
set_line_width(cr, 6.0);

arc(cr, xc, yc, 10.0, 0, 2*pi);
fill(cr);

arc(cr, xc, yc, radius, angle1, angle1);
line_to(cr, xc, yc);
arc(cr, xc, yc, radius, angle2, angle2);
line_to(cr, xc, yc);
stroke(cr);

## mark picture with current date
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_arc.png");

## header to provide surface and context
using Cairo
using Printf

c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);

set_font_face(cr, "Sans 16")

text(cr,40.0,40.0,"E<span foreground=\"white\" background=\"blue\">F</span>",markup=true)
text(cr,40.0,60.0,"EGDC")

text(cr,40.0,90.0,"<span foreground=\"white\" background=\"red\">E</span>FGH",markup=true)
text(cr,40.0,110.0,"EGDC",markup=true)

text(cr,40.0,140.0,"G<span foreground=\"white\" background=\"green4\">E</span>FJ",markup=true)
text(cr,40.0,160.0,"EGDC")


## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_pango_text1.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, following here
set_line_width(cr, 40.96);
move_to(cr, 76.8, 84.48);
rel_line_to(cr, 51.2, -51.2);
rel_line_to(cr, 51.2, 51.2);
set_line_join(cr, Cairo.CAIRO_LINE_JOIN_MITER); # default 
stroke(cr);

move_to(cr, 76.8, 161.28);
rel_line_to(cr, 51.2, -51.2);
rel_line_to(cr, 51.2, 51.2);
set_line_join(cr, Cairo.CAIRO_LINE_JOIN_BEVEL);
stroke(cr);

move_to(cr, 76.8, 238.08);
rel_line_to(cr, 51.2, -51.2);
rel_line_to(cr, 51.2, 51.2);
set_line_join(cr, Cairo.CAIRO_LINE_JOIN_ROUND);
stroke(cr);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_set_line_join.png");

## Cairo Constants ##

# deprecated exports---do not add more!
export CAIRO_FORMAT_ARGB32,
    CAIRO_FORMAT_RGB24,
    CAIRO_FORMAT_A8,
    CAIRO_FORMAT_A1,
    CAIRO_FORMAT_RGB16_565,
    CAIRO_CONTENT_COLOR,
    CAIRO_CONTENT_ALPHA,
    CAIRO_CONTENT_COLOR_ALPHA,
    CAIRO_FILTER_FAST,
    CAIRO_FILTER_GOOD,
    CAIRO_FILTER_BEST,
    CAIRO_FILTER_NEAREST,
    CAIRO_FILTER_BILINEAR,
    CAIRO_FILTER_GAUSSIAN

const format_t = Int32
const FORMAT_INVALID   = Int32(-1)
const FORMAT_ARGB32    = Int32(0)
const FORMAT_RGB24     = Int32(1)
const FORMAT_A8        = Int32(2)
const FORMAT_A1        = Int32(3)
const FORMAT_RGB16_565 = Int32(4)
const FORMAT_RGB30     = Int32(5)

const status_t = Int32
const STATUS_SUCCESS                   = Int32(0)
const STATUS_NO_MEMORY                 = Int32(1)
const STATUS_INVALID_RESTORE           = Int32(2)
const STATUS_INVALID_POP_GROUP         = Int32(3)
const STATUS_NO_CURRENT_POINT          = Int32(4)
const STATUS_INVALID_MATRIX            = Int32(5)
const STATUS_INVALID_STATUS            = Int32(6)
const STATUS_NULL_POINTER              = Int32(7)
const STATUS_INVALID_STRING            = Int32(8)
const STATUS_INVALID_PATH_DATA         = Int32(9)
const STATUS_READ_ERROR                = Int32(10)
const STATUS_WRITE_ERROR               = Int32(11)
const STATUS_SURFACE_FINISHED          = Int32(12)
const STATUS_SURFACE_TYPE_MISMATCH     = Int32(13)
const STATUS_PATTERN_TYPE_MISMATCH     = Int32(14)
const STATUS_INVALID_CONTENT           = Int32(15)
const STATUS_INVALID_FORMAT            = Int32(16)
const STATUS_INVALID_VISUAL            = Int32(17)
const STATUS_FILE_NOT_FOUND            = Int32(17)
const STATUS_INVALID_DASH              = Int32(18)
const STATUS_INVALID_DSC_COMMENT       = Int32(19)
const STATUS_INVALID_INDEX             = Int32(20)
const STATUS_CLIP_NOT_REPRESENTABLE    = Int32(21)
const STATUS_TEMP_FILE_ERROR           = Int32(22)
const STATUS_INVALID_STRIDE            = Int32(23)
const STATUS_FONT_TYPE_MISMATCH        = Int32(24)
const STATUS_USER_FONT_IMMUTABLE       = Int32(25)
const STATUS_USER_FONT_ERROR           = Int32(26)
const STATUS_NEGATIVE_COUNT            = Int32(27)
const STATUS_INVALID_CLUSTERS          = Int32(28)
const STATUS_INVALID_SLANT             = Int32(29)
const STATUS_INVALID_WEIGHT            = Int32(30)
const STATUS_INVALID_SIZE              = Int32(31)
const STATUS_USER_FONT_NOT_IMPLEMENTED = Int32(32)
const STATUS_DEVICE_TYPE_MISMATCH      = Int32(33)
const STATUS_DEVICE_ERROR              = Int32(34)
const STATUS_INVALID_MESH_CONSTRUCTION = Int32(35)
const STATUS_DEVICE_FINISHED           = Int32(36)
const STATUS_LAST_STATUS               = Int32(37)

const surface_t = Int32
const CAIRO_SURFACE_TYPE_IMAGE            = Int32(0)
const CAIRO_SURFACE_TYPE_PDF,             = Int32(1)
const CAIRO_SURFACE_TYPE_PS,              = Int32(2)
const CAIRO_SURFACE_TYPE_XLIB,            = Int32(3)
const CAIRO_SURFACE_TYPE_XCB,             = Int32(4)
const CAIRO_SURFACE_TYPE_GLITZ,           = Int32(5)
const CAIRO_SURFACE_TYPE_QUARTZ,          = Int32(6)
const CAIRO_SURFACE_TYPE_WIN32,           = Int32(7)
const CAIRO_SURFACE_TYPE_BEOS,            = Int32(8)
const CAIRO_SURFACE_TYPE_DIRECTFB,        = Int32(9)
const CAIRO_SURFACE_TYPE_SVG,             = Int32(10)
const CAIRO_SURFACE_TYPE_OS2,             = Int32(11)
const CAIRO_SURFACE_TYPE_WIN32_PRINTING,  = Int32(12)
const CAIRO_SURFACE_TYPE_QUARTZ_IMAGE,    = Int32(13)
const CAIRO_SURFACE_TYPE_SCRIPT,          = Int32(14)
const CAIRO_SURFACE_TYPE_QT,              = Int32(15)
const CAIRO_SURFACE_TYPE_RECORDING,       = Int32(16)
const CAIRO_SURFACE_TYPE_VG,              = Int32(17)
const CAIRO_SURFACE_TYPE_GL,              = Int32(18)
const CAIRO_SURFACE_TYPE_DRM,             = Int32(19)
const CAIRO_SURFACE_TYPE_TEE,             = Int32(20)
const CAIRO_SURFACE_TYPE_XML,             = Int32(21)
const CAIRO_SURFACE_TYPE_SKIA,            = Int32(22)
const CAIRO_SURFACE_TYPE_SUBSURFACE,      = Int32(23)
const CAIRO_SURFACE_TYPE_COGL             = Int32(24)


const font_slant_t = Int32
const FONT_SLANT_NORMAL  = Int32(0)
const FONT_SLANT_ITALIC  = Int32(1)
const FONT_SLANT_OBLIQUE = Int32(2)

const font_weight_t = Int32
const FONT_WEIGHT_NORMAL = Int32(0)
const FONT_WEIGHT_BOLD = Int32(1)

const CONTENT_COLOR = Int32(0x1000)
const CONTENT_ALPHA = Int32(0x2000)
const CONTENT_COLOR_ALPHA = Int32(0x3000)

const FILTER_FAST = 0
const FILTER_GOOD = 1
const FILTER_BEST = 2
const FILTER_NEAREST = 3
const FILTER_BILINEAR = 4
const FILTER_GAUSSIAN = 5

const EXTEND_NONE = 0
const EXTEND_REPEAT = 1
const EXTEND_REFLECT = 2
const EXTEND_PAD = 3

const ANTIALIAS_DEFAULT = 0
const ANTIALIAS_NONE = 1
const ANTIALIAS_GRAY = 2
const ANTIALIAS_SUBPIXEL = 3
# next 3 are not available on all Cairo installations (only since 1.12)
const ANTIALIAS_FAST = 4
const ANTIALIAS_GOOD = 5
const ANTIALIAS_BEST = 6

const OPERATOR_CLEAR = 0
const OPERATOR_SOURCE = 1
const OPERATOR_OVER = 2
const OPERATOR_IN = 3
const OPERATOR_OUT = 4
const OPERATOR_ATOP = 5
const OPERATOR_DEST = 6
const OPERATOR_DEST_OVER = 7
const OPERATOR_DEST_IN = 8
const OPERATOR_DEST_OUT = 9
const OPERATOR_DEST_ATOP = 10
const OPERATOR_XOR = 11
const OPERATOR_ADD = 12
const OPERATOR_SATURATE = 13
const OPERATOR_MULTIPLY = 14
const OPERATOR_SCREEN = 15
const OPERATOR_OVERLAY = 16
const OPERATOR_DARKEN = 17
const OPERATOR_LIGHTEN = 18


## LaTex Token Dicts ##
const _common_token_dict = Dict(
    "\\{"              => "{",
    "\\}"              => "}",
    "\\_"              => "_",
    "\\^"              => "^",
    "\\-"              => "-",

    ## ignore stray brackets
    "{"                => "",
    "}"                => ""
)

const _text_token_dict = Dict(
    ## non-math symbols (p438)
    "\\S"              => "\ua7",
    "\\P"              => "\ub6",
    "\\dag"            => "\u2020",
    "\\ddag"           => "\u2021"
)

const _math_token_dict = Dict(

    "-"                => "\u2212", # minus sign

    ## spacing
    "\\quad"           => "\u2003", # 1 em
    "\\qquad"          => "\u2003\u2003", # 2 em
    "\\,"              => "\u2006", # 3/18 em
    "\\>"              => "\u2005", # 4/18 em
    "\\;"              => "\u2004", # 5/18 em

    ## lowercase greek
    "\\alpha"          => "\u03b1",
    "\\beta"           => "\u03b2",
    "\\gamma"          => "\u03b3",
    "\\delta"          => "\u03b4",
    "\\epsilon"        => "\u03b5",
    "\\varepsilon"     => "\u03f5",
    "\\zeta"           => "\u03b6",
    "\\eta"            => "\u03b7",
    "\\theta"          => "\u03b8",
    "\\vartheta"       => "\u03d1",
    "\\iota"           => "\u03b9",
    "\\kappa"          => "\u03ba",
    "\\lambda"         => "\u03bb",
    "\\mu"             => "\u03bc",
    "\\nu"             => "\u03bd",
    "\\xi"             => "\u03be",
    "\\omicron"        => "\u03bf",
    "\\pi"             => "\u03c0",
    "\\varpi"          => "\u03d6",
    "\\rho"            => "\u03c1",
    "\\varrho"         => "\u03f1",
    "\\sigma"          => "\u03c3",
    "\\varsigma"       => "\u03c2",
    "\\tau"            => "\u03c4",
    "\\upsilon"        => "\u03c5",
    "\\phi"            => "\u03d5",
    "\\varphi"         => "\u03c6",
    "\\chi"            => "\u03c7",
    "\\psi"            => "\u03c8",
    "\\omega"          => "\u03c9",

    ## uppercase greek
    "\\Alpha"           => "\u0391",
    "\\Beta"            => "\u0392",
    "\\Gamma"           => "\u0393",
    "\\Delta"           => "\u0394",
    "\\Epsilon"         => "\u0395",
    "\\Zeta"            => "\u0396",
    "\\Eta"             => "\u0397",
    "\\Theta"           => "\u0398",
    "\\Iota"            => "\u0399",
    "\\Kappa"           => "\u039a",
    "\\Lambda"          => "\u039b",
    "\\Mu"              => "\u039c",
    "\\Nu"              => "\u039d",
    "\\Xi"              => "\u039e",
    "\\Pi"              => "\u03a0",
    "\\Rho"             => "\u03a1",
    "\\Sigma"           => "\u03a3",
    "\\Tau"             => "\u03a4",
    "\\Upsilon"         => "\u03a5",
    "\\Phi"             => "\u03a6",
    "\\Chi"             => "\u03a7",
    "\\Psi"             => "\u03a8",
    "\\Omega"           => "\u03a9",

    ## miscellaneous
    "\\aleph"           => "\u2135",
    "\\hbar"            => "\u210f",
    "\\ell"             => "\u2113",
    "\\wp"              => "\u2118",
    "\\Re"              => "\u211c",
    "\\Im"              => "\u2111",
    "\\partial"         => "\u2202",
    "\\infty"           => "\u221e",
    "\\prime"           => "\u2032",
    "\\emptyset"        => "\u2205",
    "\\nabla"           => "\u2206",
    "\\surd"            => "\u221a",
    "\\top"             => "\u22a4",
    "\\bot"             => "\u22a5",
    "\\|"               => "\u2225",
    "\\angle"           => "\u2220",
    "\\triangle"        => "\u25b3", # == \bigtriangleup
    "\\backslash"       => "\u2216",
    "\\forall"          => "\u2200",
    "\\exists"          => "\u2203",
    "\\neg"             => "\uac",
    "\\flat"            => "\u266d",
    "\\natural"         => "\u266e",
    "\\sharp"           => "\u266f",
    "\\clubsuit"        => "\u2663",
    "\\diamondsuit"     => "\u2662",
    "\\heartsuit"       => "\u2661",
    "\\spadesuit"       => "\u2660",

    ## large operators
    "\\sum"             => "\u2211",
    "\\prod"            => "\u220f",
    "\\coprod"          => "\u2210",
    "\\int"             => "\u222b",
    "\\oint"            => "\u222e",
    "\\bigcap"          => "\u22c2",
    "\\bigcup"          => "\u22c3",
    "\\bigscup"         => "\u2a06",
    "\\bigvee"          => "\u22c1",
    "\\bigwedge"        => "\u22c0",
    "\\bigodot"         => "\u2a00",
    "\\bigotimes"       => "\u2a02",
    "\\bigoplus"        => "\u2a01",
    "\\biguplus"        => "\u2a04",

    ## binary operations
    "\\pm"              => "\ub1",
    "\\mp"              => "\u2213",
    "\\setminus"        => "\u2216",
    "\\cdot"            => "\u22c5",
    "\\times"           => "\ud7",
    "\\ast"             => "\u2217",
    "\\star"            => "\u22c6",
    "\\diamond"         => "\u22c4",
    "\\circ"            => "\u2218",
    "\\bullet"          => "\u2219",
    "\\div"             => "\uf7",
    "\\cap"             => "\u2229",
    "\\cup"             => "\u222a",
    "\\uplus"           => "\u228c", # 228e?
    "\\sqcap"           => "\u2293",
    "\\sqcup"           => "\u2294",
    "\\triangleleft"    => "\u22b2",
    "\\triangleright"   => "\u22b3",
    "\\wr"              => "\u2240",
    "\\bigcirc"         => "\u25cb",
    "\\bigtriangleup"   => "\u25b3", # == \triangle
    "\\bigtriangledown" => "\u25bd",
    "\\vee"             => "\u2228",
    "\\wedge"           => "\u2227",
    "\\oplus"           => "\u2295",
    "\\ominus"          => "\u2296",
    "\\otimes"          => "\u2297",
    "\\oslash"          => "\u2298",
    "\\odot"            => "\u2299",
    "\\dagger"          => "\u2020",
    "\\ddagger"         => "\u2021",
    "\\amalg"           => "\u2210",

    ## relations
    "\\leq"             => "\u2264",
    "\\prec"            => "\u227a",
    "\\preceq"          => "\u227c",
    "\\ll"              => "\u226a",
    "\\subset"          => "\u2282",
    "\\subseteq"        => "\u2286",
    "\\sqsubseteq"      => "\u2291",
    "\\in"              => "\u2208",
    "\\vdash"           => "\u22a2",
    "\\smile"           => "\u2323",
    "\\frown"           => "\u2322",
    "\\geq"             => "\u2265",
    "\\succ"            => "\u227b",
    "\\succeq"          => "\u227d",
    "\\gg"              => "\u226b",
    "\\supset"          => "\u2283",
    "\\supseteq"        => "\u2287",
    "\\sqsupseteq"      => "\u2292",
    "\\ni"              => "\u220b",
    "\\dashv"           => "\u22a3",
    "\\mid"             => "\u2223",
    "\\parallel"        => "\u2225",
    "\\equiv"           => "\u2261",
    "\\sim"             => "\u223c",
    "\\simeq"           => "\u2243",
    "\\asymp"           => "\u224d",
    "\\approx"          => "\u2248",
    "\\cong"            => "\u2245",
    "\\bowtie"          => "\u22c8",
    "\\propto"          => "\u221d",
    "\\models"          => "\u22a7", # 22a8?
    "\\doteq"           => "\u2250",
    "\\perp"            => "\u27c2",

    ## arrows
    "\\leftarrow"       => "\u2190",
    "\\Leftarrow"       => "\u21d0",
    "\\rightarrow"      => "\u2192",
    "\\Rightarrow"      => "\u21d2",
    "\\leftrightarrow"  => "\u2194",
    "\\Leftrightarrow"  => "\u21d4",
    "\\mapsto"          => "\u21a6",
    "\\hookleftarrow"   => "\u21a9",
    "\\leftharpoonup"   => "\u21bc",
    "\\leftharpoondown" => "\u21bd",
    "\\rightleftharpoons" => "\u21cc",
    "\\longleftarrow"   => "\u27f5",
    "\\Longleftarrow"   => "\u27f8",
    "\\longrightarrow"  => "\u27f6",
    "\\Longrightarrow"  => "\u27f9",
    "\\longleftrightarrow" => "\u27f7",
    "\\Longleftrightarrow" => "\u27fa",
    "\\hookrightarrow"  => "\u21aa",
    "\\rightharpoonup"  => "\u21c0",
    "\\rightharpoondown" => "\u21c1",
    "\\uparrow"         => "\u2191",
    "\\Uparrow"         => "\u21d1",
    "\\downarrow"       => "\u2193",
    "\\Downarrow"       => "\u21d3",
    "\\updownarrow"     => "\u2195",
    "\\Updownarrow"     => "\u21d5",
    "\\nearrow"         => "\u2197",
    "\\searrow"         => "\u2198",
    "\\swarrow"         => "\u2199",
    "\\nwarrow"         => "\u2196",

    ## openings
#    "\\lbrack"          => "[",
#    "\\lbrace"          => "{",
    "\\langle"          => "\u27e8",
    "\\lfloor"          => "\u230a",
    "\\lceil"           => "\u2308",

    ## closings
#    "\\rbrack"          => "]",
#    "\\rbrace"          => "}",
    "\\rangle"          => "\u27e9",
    "\\rfloor"          => "\u230b",
    "\\rceil"           => "\u2309",

    ## alternate names
    "\\ne"              => "\u2260",
    "\\neq"             => "\u2260",
    "\\le"              => "\u2264",
    "\\ge"              => "\u2265",
    "\\to"              => "\u2192",
    "\\gets"            => "\u2192",
    "\\owns"            => "\u220b",
    "\\land"            => "\u2227",
    "\\lor"             => "\u2228",
    "\\lnot"            => "\uac",
    "\\vert"            => "\u2223",
    "\\Vert"            => "\u2225",

    ## extensions
    "\\deg"             => "\ub0",
    "\\degr"            => "\ub0",
    "\\degree"          => "\ub0",
    "\\degrees"         => "\ub0",
    "\\arcdeg"          => "\ub0",
    "\\arcmin"          => "\u2032",
    "\\arcsec"          => "\u2033"
)

const CAIRO_FILL_RULE_WINDING = Int32(0);
const CAIRO_FILL_RULE_EVEN_ODD = Int32(1);

const CAIRO_LINE_CAP_BUTT = Int32(0);
const CAIRO_LINE_CAP_ROUND = Int32(1);
const CAIRO_LINE_CAP_SQUARE = Int32(2);

const CAIRO_LINE_JOIN_MITER = Int32(0);
const CAIRO_LINE_JOIN_ROUND = Int32(1);
const CAIRO_LINE_JOIN_BEVEL = Int32(2);

#typedef enum _cairo_path_data_type {
#    CAIRO_PATH_MOVE_TO,
#    CAIRO_PATH_LINE_TO,
#    CAIRO_PATH_CURVE_TO,
#    CAIRO_PATH_CLOSE_PATH
#} cairo_path_data_type_t;

const CAIRO_PATH_MOVE_TO = Int32(0);
const CAIRO_PATH_LINE_TO = Int32(1);
const CAIRO_PATH_CURVE_TO = Int32(2);
const CAIRO_PATH_CLOSE_PATH = Int32(3);

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);

## original example, following here

x=25.6;  y=128.0;
x1=102.4; y1=230.4;
x2=153.6; y2=25.6;
x3=230.4; y3=128.0;

move_to(cr, x, y);
curve_to(cr, x1, y1, x2, y2, x3, y3);

set_line_width(cr, 10.0);
stroke(cr);

set_source_rgba(cr, 1, 0.2, 0.2, 0.6);
set_line_width(cr, 6.0);
move_to(cr,x,y);   line_to(cr,x1,y1);
move_to(cr,x2,y2); line_to(cr,x3,y3);
stroke(cr);

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_curve_to.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, following here
select_font_face(cr, "Sans", Cairo.FONT_SLANT_NORMAL,
                 Cairo.FONT_WEIGHT_NORMAL);
set_font_size(cr, 100.0);
extents = text_extents(cr, "cairo");

#
# typedef struct {
#     double x_bearing;
#     double y_bearing;
#     double width;
#     double height;
#     double x_advance;
#     double y_advance;
# } cairo_text_extents_t;

x = 25.0;
y = 150.0;

move_to(cr, x, y);
show_text(cr, "cairo");

# draw helping lines 
set_source_rgba(cr, 1, 0.2, 0.2, 0.6);
set_line_width(cr, 6.0);
arc(cr, x, y, 10.0, 0, 2*pi);
fill(cr);
move_to(cr, x,y);
rel_line_to(cr, 0, -extents[4]);
rel_line_to(cr, extents[3], 0);
rel_line_to(cr, extents[1], -extents[2]);
stroke(cr);
## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_text_extents.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);
## original example, following here

select_font_face(cr, "Sans", Cairo.FONT_SLANT_NORMAL,
                 Cairo.FONT_WEIGHT_BOLD);
set_font_size(cr, 90.0);

move_to(cr, 10.0, 135.0);
show_text(cr, "Hello");

move_to(cr, 70.0, 165.0);
text_path(cr, "void");
set_source_rgb(cr, 0.5, 0.5, 1);
fill_preserve(cr);
set_source_rgb(cr, 0, 0, 0);
set_line_width(cr, 2.56);
stroke(cr);

# draw helping lines
set_source_rgba(cr, 1, 0.2, 0.2, 0.6);
arc(cr, 10.0, 135.0, 5.12, 0, 2*pi);
close_path(cr);
arc(cr, 70.0, 165.0, 5.12, 0, 2*pi);
fill(cr);


## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_text.png");

## header to provide surface and context
using Cairo
c = CairoRGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgb(cr,0.8,0.8,0.8);    # light gray
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);

save(cr);

## api example, use set_line_type

dashes_by_name = [
    "solid",
    "dot",
    "dotdashed",
    "longdashed",
    "dash",
    "dotdotdashed",
    "dotdotdotdashed"]

set_line_width(cr, 3.0);

for k=1:7
    save(cr)
    set_line_type(cr, dashes_by_name[k])
    move_to(cr,16.0,16.0+(k*32.0))
    line_to(cr,240.0,16.0+(k*32.0))
    stroke(cr)
    restore(cr)
end

## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_set_dash.png");

using Cairo

function common_header()
    ## header to provide surface and context
    c = CairoRGBSurface(256,256);
    cr = CairoContext(c);

    save(cr);
    set_source_rgb(cr,0.8,0.8,0.8);    # light gray
    rectangle(cr,0.0,0.0,256.0,256.0); # background
    fill(cr);
    restore(cr);

    return c,cr
end

function write_out_picture(filename::AbstractString,c::CairoSurface)
    ## mark picture with current date
    move_to(cr,0.0,12.0);
    set_source_rgb(cr, 0,0,0);
    show_text(cr,Libc.strftime(time()));
    ##
    write_to_png(c,filename);
    nothing
end

function example_current_point(cr)
    save(cr);

    x=25.6;  y=128.0;
    x1=102.4; y1=30.4;
    x2=123.6; y2=45.6;
    x3=130.4; y3=128.0;

    move_to(cr, x, y);
    curve_to(cr, x1, y1, x2, y2, x3, y3);

    if has_current_point(cr)
        x,y = get_current_point(cr);
        save(cr)
        move_to(cr,x,y)
        set_source_rgb(cr, 0,0,1.0);
        show_text(cr,"current point")
        restore(cr)
    end

set_line_width(cr, 10.0);
stroke(cr);


    restore(cr);
    save(cr);
    
    nothing
end


c,cr = common_header();
save(cr);
example_current_point(cr);
restore(cr);
write_out_picture("sample_current_point.png",c);

## header to provide surface and context
using Cairo
c = CairoARGBSurface(256,256);
cr = CairoContext(c);

save(cr);
set_source_rgba(cr,0.0,0.0,0.0,0.0); # transparent black
rectangle(cr,0.0,0.0,256.0,256.0); # background
fill(cr);
restore(cr);
save(cr);

s1 = CairoRecordingSurface()
c1 = CairoContext(s1)

## original example, following here
move_to(c1, 128.0, 25.6);
line_to(c1, 230.4, 230.4);
rel_line_to(c1, -102.4, 0.0);
curve_to(c1, 51.2, 230.4, 51.2, 128.0, 128.0, 128.0);
close_path(c1);

move_to(c1, 64.0, 25.6);
rel_line_to(c1, 51.2, 51.2);
rel_line_to(c1, -51.2, 51.2);
rel_line_to(c1, -51.2, -51.2);
close_path(c1);

set_line_width(c1, 10.0);
set_source_rgb(c1, 0, 0, 1);
fill_preserve(c1);
set_source_rgb(c1, 0, 0, 0);
stroke(c1);

## now using the recorded painting 
set_source(cr, s1, 0.0, 0.0)
paint(cr)


## mark picture with current date
restore(cr);
move_to(cr,0.0,12.0);
set_source_rgb(cr, 0,0,0);
show_text(cr,Libc.strftime(time()));
write_to_png(c,"sample_record0.png");

## Sample programs #

This is roughly a copy of the sample code listed at [cairographics.org/samples](http://www.cairographics.org/samples/).
These examples are C code and assume that you've already set up a Cairo surface and Cairo Context.

This (samples) directory contains ports of these examples to julia, additionally creating the Surface and Context, adding a time-stamp to the image, and saving the result to a .png file.

### arc #

Example of using the arc path operator [sample_arc.jl](sample_arc.jl).
Note: The path creation starts without current point, otherwise there would be a linesegment first, before starting of the arc.

![arc .png](sample_arc.png "arc example")

### arc_negative #

Example of using the arc_negative path operator [sample_arc_negative.jl](sample_arc_negative.jl).

![arc_negative .png](sample_arc_negative.png "arc negative example")

### clip #

A clip path, a circle is defined, then the drawing is done [sample_clip.jl](sample_clip.jl).

![clip .png](sample_clip.png "clip example")

### clip image #

Like the previous, but now inserting a picture by reading a .png to an Image Surface. Note: the function is called read_from_png and creates an Image Surface; while in pure C cairo this would be a call of cairo_image_surface_create_from_png [sample_clip_image.jl](sample_clip_image.jl).

![clip image.png](sample_clip_image.png "clip image example")

### curve rectangle #

Example of more complex path construction, here a rectangle constructed be four bezier segments. Note: Different as in the original example, this here now puts the path construction and stroke and fill operations into a function with coordinates and corner radius as arguments [sample_curve_rectangle.jl](sample_curve_rectangle.jl).

![curve rectangle .png](sample_curve_rectangle.png "curve rectangle example")

### curve to #

Example of using the curve to path operator, which adds a cubic Bézier spline to the current path [sample_curve_to.jl](sample_curve_to.jl).

![curve to .png](sample_curve_to.png "curve to example")

### dash #

Example of using a dash line pattern for stroking a path. Note: the julia set_dash uses the length of the dash array to set the ndash internally [sample_dash.jl](sample_dash.jl).

![dash .png](sample_dash.png "dash example")

### fill and stroke 2 #

Example of creating a path of non connected areas and fill - while preserving the path - and stroke [sample_fill_and_stroke2.jl](sample_fill_and_stroke2.jl).

![fill and stroke2 .png](sample_fill_and_stroke2.png "fill and stroke2 example")

### fill style #

Exmaple of using the different fill rules. The same path is filled and stroked [sample_fill_style.jl](sample_fill_style.jl). Note: the julia function is called set_fill_type while the pure C cairo is called with set_fill_rule.

![fill style .png](sample_fill_style.png "fill style example")

### gradient #

Example of gradients - both linear and radiant - as definition and used for filling [sample_gradient.jl](sample_gradient.jl).

![gradient .png](sample_gradient.png "gradient example")

### image #

Example of painting with a Image Surface as source [sample_image.jl](sample_image.jl).

![image .png](sample_image.png "image example")

### image pattern #

Example of painting with a Image Surface as pattern [sample_imagepattern.jl](sample_imagepattern.jl).

![imagepattern .png](sample_imagepattern.png "imagepattern example")

### multi segment caps #

Example of stroking a path with non connected segments [sample_multi_segment_caps.jl](sample_multi_segment_caps.jl).

![multi segment caps .png](sample_multi_segment_caps.png "multi segment caps example")

### rounded rectangle #

Example of more path operators, custom shape could be wrapped in a function [sample_rounded_rectangle.jl](sample_rounded_rectangle.jl).

![rounded rectangle .png](sample_rounded_rectangle.png "rounded rectangle example")

### set line caps

Examples of the line cap settings [sample_set_line_cap.jl](sample_set_line_cap.jl).

![set line cap .png](sample_set_line_cap.png "line caps example")

### set line join

Examples of the line join settings [sample_set_line_join.jl](sample_set_line_join.jl).

![set line join .png](sample_set_line_join.png "line join example")

### text

Example of setting text, one with text_show, second with text_path extending the current path and fill and stroke the outline [sample_text.jl](sample_text.jl).

![text .png](sample_text.png "text example")

### text align center

Example of getting the text extents, then centering the text around 128.0,128.0 [sample_text_align_center.jl](sample_text_align_center.jl).

![text align center.png](sample_text_align_center.png "text align example")

### text extents

Example of getting the text extents, plotting the dimension [sample_text_extents.jl](sample_text_extents.jl).

![text extents .png](sample_text_extents.png "text extents example")

### copy path

Example of getting the path to a single character via text_path, copy_path and convert to an Array of CairoPathEntry [sample_copy_path.jl](sample_copy_path.jl). 

![copy path .png](sample_copy_path.png "copy path example")

### image (from stream)

Example of painting with a Image Surface as source that was created by reading from a stream. The example reads the png data from an inline string [sample_imagestream.jl](sample_imagestream.jl).

![image .png](sample_imagestream.png "imagestream example")


## More Samples for Testing

The following examples have been created to have more coverage in testing (all samples_X are executed).

### alpha paint

Example to use set_source with different input (for multiple dispatch). For better viewing the background is not plain gray anymore, but has structure
[sample_alpha_paint.jl](sample_alpha_paint.jl).

![alpha paint .png](sample_alpha_paint.png "set source example")

### image copy

Example to use copy(Image). You need to take care about coordinate transformation, as the copy is inplace [sample_image_copy.jl](sample_image_copy.jl).

![image copy .png](sample_image_copy.png "image copy example")

### operators

Example to use the defined operators for set_operator with two filled rectangles [sample_operators.jl](sample_operators.jl).

![operators .png](sample_operators.png "operators example")

### set dash

Example to use the set line type function (input to set_dash) [sample_set_dash.jl](sample_set_dash.jl).

![set dash .png](sample_set_dash.png "line type example")

### copy path flat

[sample_copy_path_flat.jl](sample_copy_path_flat.jl). 

![copy path flat.png](sample_copy_path_flat.png "copy path flat example")

### pango text

Example of a few (but not all) pango text formating options [sample_pango_text.jl](sample_pango_text.jl).

![pango text.png](sample_pango_text.png "pango text example")

### mesh pattern

Example of creating and using a mesh pattern [sample_meshpattern.jl](sample_meshpattern.jl). 
Mesh patterns are tensor-product patch meshes (type 7 shadings in PDF), read more in [http://www.cairographics.org/manual/cairo-cairo-pattern-t.html#cairo-pattern-create-mesh] or [http://www.w3.org/TR/SVG2/pservers.html#MeshGradients].

![mesh pattern .png](sample_meshpattern.png "mesh pattern example")

### Recording and Scripting Surfaces

Example of using Recording surface, simple copy, then scaled and offset.

![sample record0.png](sample_record0.png "record0 example")
![sample record1.png](sample_record1.png "record1 example")

Example of writing to script, put script text into frame. [sample_record0.jl](sample_record0.jl), [sample_record1.jl](sample_record1.jl)

![sample script0.png](sample_script0.png "scrip0 example")

### current point 

Example of using current point [sample_current_point.jl](sample_current_point.jl)

![sample current point.png](sample_current_point.png "current point example")
